#include "cps.h"

/*========================================================================
 Three wonders - All-in-One (W.I.P.) Driver by Mike_Haggar_99@hotmail.com
 Cheat engine source by HyperYagami
 Added Dip A/B/C by Bigfool
 HyperYagami: cheats
========================================================================*/

static struct BurnInputInfo DrvInputList[]=
{
  {"P1 Coin"       , 0, CpsInp018+0, "p1 coin"  },
  {"P1 Start"      , 0, CpsInp018+4, "p1 start" },
  {"P1 Up"         , 0, CpsInp001+3, "p1 up"    },
  {"P1 Down"       , 0, CpsInp001+2, "p1 down"  },
  {"P1 Left"       , 0, CpsInp001+1, "p1 left"  },
  {"P1 Right"      , 0, CpsInp001+0, "p1 right" },
  {"P1 Button 1"   , 0, CpsInp001+4, "p1 fire 1"},
  {"P1 Button 2"   , 0, CpsInp001+5, "p1 fire 2"},

  {"P2 Coin"       , 0, CpsInp018+1, "p2 coin"  },
  {"P2 Start"      , 0, CpsInp018+5, "p2 start" },
  {"P2 Up"         , 0, CpsInp000+3, "p2 up"    },
  {"P2 Down"       , 0, CpsInp000+2, "p2 down"  },
  {"P2 Left"       , 0, CpsInp000+1, "p2 left"  },
  {"P2 Right"      , 0, CpsInp000+0, "p2 right" },
  {"P2 Button 1"   , 0, CpsInp000+4, "p2 fire 1"},
  {"P2 Button 2"   , 0, CpsInp000+5, "p2 fire 2"},

  {"Reset"         , 0, &CpsReset,   "reset"    },
  {"Diagnostic"    , 0, CpsInp018+6, "diag"     },
  {"Service"       , 0, CpsInp018+2, "service"  },
};

// Return 0 if a input number is defined, and (if pii!=NULL) information about each input
static int DrvInputInfo(struct BurnInputInfo *pii,unsigned int i)
{
  unsigned int nDrvCount=0;
  nDrvCount=sizeof(DrvInputList) /sizeof(DrvInputList[0]);
  if (i<nDrvCount) { if (pii!=NULL) *pii=DrvInputList[i];  return 0; }
  else SETUP_THE_CHEAT_LIST
  else SETUP_THE_DIPSW_LIST
  return 1;
}

static int DrvScode(unsigned int n)
{
  if (n>=0x20 && n<=0x45) return 2;
  if (n>=0x53 && n<=0x5a) return 2;
  if (n>=0x60 && n<=0x62) return 2;
  if (n>=0x73 && n<=0x74) return 2;
  if (n>=0x79 && n<=0x7b) return 2;
  if (n>=0x7d && n<=0x7e) return 2;
  if (n==0xc0 || n==0xc2 || n==0xc4) return 2;
  if (n>=0xc6 && n<=0xc8) return 2;
  if (n>=0xe4 && n<=0xe6) return 2;
  return 1;
}

static int DrvInit()
{
  int nRet=0;
  Cps=1; Wonders3=1;
  nCpsRomLen=   0x100000;
  nCpsCodeLen=0; // not encrypted
  nCpsGfxLen= 8*0x080000;
  nCpsZRomLen=  0x010000;
  nCpsAdLen  =2*0x020000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  // Load program roms
  nRet=BurnLoadRom(CpsRom+0x000001,0,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x000000,1,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x040001,2,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x040000,3,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x080001,4,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x080000,5,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x0c0001,6,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x0c0000,7,2); if (nRet!=0) return 1;
  // Set dip switches
  SETUP_DIPSW_3(Cpi01A,Cpi01C,Cpi01E,0x00,0x03,0x60);
  // Load graphics roms
  CpsLoadTiles(CpsGfx         ,8);
  CpsLoadTiles(CpsGfx+0x200000,12);

  nCpsGfxScroll[2]=0x200000;

  nCpsLcReg=0x68; // Layer control register is at 0x68
  CpsLayEn[1]=0x20;
  CpsLayEn[2]=0x04;
  CpsLayEn[3]=0x08;

  // Board ID improvments by KEV. 0x72,0x0800
  CpsBID[0]=0x72;
  CpsBID[1]=0x08;
  CpsBID[2]=0x00;

  // Protection enable code by KEV
  CpsMProt[0]=0x4e;
  CpsMProt[1]=0x4c;
  CpsMProt[2]=0x4a;
  CpsMProt[3]=0x48;

  MaskAddr[0]=0x66;
  MaskAddr[1]=0x64;
  MaskAddr[2]=0x62;
  MaskAddr[3]=0x60;

  // Load Z80 Rom
  nRet=BurnLoadRom(CpsZRom,16,1);
  nPsndIrqPeriod=(60<<10)/250; //OLDTST
  BurnScode=DrvScode;

  // Load ADPCM data
  nRet=BurnLoadRom(CpsAd        ,17,1);
  nRet=BurnLoadRom(CpsAd+0x20000,18,1);

  ConstructCheatList();
  ConstructDIPSWList();

  nRet=CpsRunInit(); if (nRet!=0) return 1;
  // Ready to go
  return 0;
}

static int DrvExit()
{

  DestroyCheatList();
  DestroyDIPSWList();

  CpsRunExit();
  BurnScode=NULL;
  nPsndIrqPeriod=0; //OLDTST

  CpsExit();
  nCpsAdLen=0; nCpsZRomLen=0; nCpsGfxLen=0; nCpsRomLen=0;
  Cps=0; Wonders3=0;
  return 0;
}

static int DrvFrame()
{
APPLY_CHEATS(CpsRamFF)

  CpsFsStopOpposite(); // stop opposite directions
  // Carry on to CPS frame
  Cps1Frame();
  return 0;
}

/*=====================
 Three Wonders (World)
=====================*/

// Count possible zip names and (if pszName!=NULL) return them
static int Wonder3wZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="3wonders.zip"; return 0; }
  return 1;
}

// Rom information
static struct StdRomInfo Wonder3wRomDesc[]=
{
  {"rte.30a"    ,0x20000,0xef5b8b33,0x10}, // 0 even 68000 code
  {"rte.35a"    ,0x20000,0x7d705529,0x10}, // 1 odd
  {"rte.31a"    ,0x20000,0x32835e5e,0x10}, // 2 even
  {"rte.36a"    ,0x20000,0x7637975f,0x10}, // 3 odd
  {"3wonders.28",0x20000,0x054137c8,0x10}, // 4 even
  {"3wonders.33",0x20000,0x7264cb1b,0x10}, // 5 odd
  {"rte.29a"    ,0x20000,0xcddaa919,0x10}, // 6 even
  {"rte.34a"    ,0x20000,0xed52e7e5,0x10}, // 7 odd

  // graphics:
  {"3wonders.05",0x80000,0x86aef804,   1}, // 8
  {"3wonders.07",0x80000,0x4f057110,   1},
  {"3wonders.01",0x80000,0x902489d0,   1},
  {"3wonders.03",0x80000,0xe35ce720,   1},
  {"3wonders.06",0x80000,0x13cb0e7c,   1}, // 12
  {"3wonders.08",0x80000,0x1f055014,   1},
  {"3wonders.02",0x80000,0xe9a034f4,   1},
  {"3wonders.04",0x80000,0xdf0eea8b,   1},

  // z80 rom
  {"3wonders.09",0x10000,0xabfca165,   1}, // 16
  // samples
  {"3wonders.18",0x20000,0x26b211ab,   1},
  {"3wonders.19",0x20000,0xdbe64ad0,   1},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Wonder3w) STD_ROM_FN(Wonder3w)

struct BurnDriver BurnDrvCps3wonders=
{
  {"3wonders","Three Wonders (World)","","Capcom","CPS1","1991",NULL},
  1,2,HARDWARE_CAPCOM_CPS1,
  Wonder3wZipName,Wonder3wRomInfo,Wonder3wRomName,DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

/*===================
 Three Wonders (USA)
===================*/

// Count possible zip names and (if pszName!=NULL) return them
static int Wonder3uZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="3wonders.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="3wonderu.zip"; return 0; }
  return 1;
}

// Rom information
static struct StdRomInfo Wonder3uRomDesc[]=
{
  {"3wonders.30",0x20000,0x0b156fd8,0x10}, // 0 even 68000 code
  {"3wonders.35",0x20000,0x57350bf4,0x10}, // 1 odd
  {"3wonders.31",0x20000,0x0e723fcc,0x10}, // 2 even
  {"3wonders.36",0x20000,0x523a45dc,0x10}, // 3 odd
  {"3wonders.28",0x20000,0x054137c8,0x10}, // 4 even
  {"3wonders.33",0x20000,0x7264cb1b,0x10}, // 5 odd
  {"3wonders.29",0x20000,0x37ba3e20,0x10}, // 6 even
  {"3wonders.34",0x20000,0xf99f46c0,0x10}, // 7 odd

  // graphics:
  {"3wonders.05",0x80000,0x86aef804,   1}, // 8
  {"3wonders.07",0x80000,0x4f057110,   1},
  {"3wonders.01",0x80000,0x902489d0,   1},
  {"3wonders.03",0x80000,0xe35ce720,   1},
  {"3wonders.06",0x80000,0x13cb0e7c,   1}, // 12
  {"3wonders.08",0x80000,0x1f055014,   1},
  {"3wonders.02",0x80000,0xe9a034f4,   1},
  {"3wonders.04",0x80000,0xdf0eea8b,   1},

  // z80 rom
  {"3wonders.09",0x10000,0xabfca165,   1}, // 16
  // samples
  {"3wonders.18",0x20000,0x26b211ab,   1},
  {"3wonders.19",0x20000,0xdbe64ad0,   1},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Wonder3u) STD_ROM_FN(Wonder3u)

struct BurnDriver BurnDrvCps3wonderu=
{
  {"3wonderu","Three Wonders (USA)","","Capcom","CPS1","1991","3wonders"},
  1,2,HARDWARE_CAPCOM_CPS1,
  Wonder3uZipName,Wonder3uRomInfo,Wonder3uRomName,DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

/*=====================
 Three Wonders (Japan)
=====================*/

// Count possible zip names and (if pszName!=NULL) return them
static int Wonder3ZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="3wonders.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="wonder3.zip"; return 0; }
  return 1;
}

// Rom information
static struct StdRomInfo Wonder3RomDesc[]=
{
  {"rtj36.bin"  ,0x20000,0xe3741247,0x10}, // 0 even 68000 code
  {"rtj42.bin"  ,0x20000,0xb4baa117,0x10}, // 1 odd
  {"rtj37.bin"  ,0x20000,0xa1f677b0,0x10}, // 2 even
  {"rtj43.bin"  ,0x20000,0x85337a47,0x10}, // 3 odd
  {"3wonders.28",0x20000,0x054137c8,0x10}, // 4 even
  {"3wonders.33",0x20000,0x7264cb1b,0x10}, // 5 odd
  {"rtj35.bin"  ,0x20000,0xe72f9ea3,0x10}, // 6 even
  {"rtj41.bin"  ,0x20000,0xa11ee998,0x10}, // 7 odd

  // graphics:
  {"3wonders.05",0x80000,0x86aef804,   1}, // 8
  {"3wonders.07",0x80000,0x4f057110,   1},
  {"3wonders.01",0x80000,0x902489d0,   1},
  {"3wonders.03",0x80000,0xe35ce720,   1},
  {"3wonders.06",0x80000,0x13cb0e7c,   1}, // 12
  {"3wonders.08",0x80000,0x1f055014,   1},
  {"3wonders.02",0x80000,0xe9a034f4,   1},
  {"3wonders.04",0x80000,0xdf0eea8b,   1},

  // z80 rom
  {"rt23.bin"   ,0x10000,0x7d5a77a7,   1}, // 16
  // samples
  {"3wonders.18",0x20000,0x26b211ab,   1},
  {"3wonders.19",0x20000,0xdbe64ad0,   1},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Wonder3) STD_ROM_FN(Wonder3)

struct BurnDriver BurnDrvCpsWonder3=
{
	{"wonder3","Wonder 3 (Japan)","","Capcom","CPS1","1991","3wonders"},
  1,2,HARDWARE_CAPCOM_CPS1,
  Wonder3ZipName,Wonder3RomInfo,Wonder3RomName,DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};
