#include "cps.h"
// Carrier Air Wing - All-in-One Driver 1.21 by Mike_Haggar_99@hotmail.com
// Load menu display adjustment by LoopMaster
// Cheat engine source by HyperYagami
// Added Dip A/B/C by Bigfool


static struct BurnInputInfo DrvInputList[]=
{
  {"P1 Coin"       , 0, CpsInp018+0, "p1 coin"},
  {"P1 Start"      , 0, CpsInp018+4, "p1 start"},
  {"P1 Up"         , 0, CpsInp001+3, "p1 up"},
  {"P1 Down"       , 0, CpsInp001+2, "p1 down"},
  {"P1 Left"       , 0, CpsInp001+1, "p1 left"},
  {"P1 Right"      , 0, CpsInp001+0, "p1 right"},
  {"P1 shot"       , 0, CpsInp001+4, "p1 fire 1"},
  {"P1 Special"    , 0, CpsInp001+5, "p1 fire 2"},

  {"P2 Coin"       , 0, CpsInp018+1, "p2 coin"},
  {"P2 Start"      , 0, CpsInp018+5, "p2 start"},
  {"P2 Up"         , 0, CpsInp000+3, "p2 up"},
  {"P2 Down"       , 0, CpsInp000+2, "p2 down"},
  {"P2 Left"       , 0, CpsInp000+1, "p2 left"},
  {"P2 Right"      , 0, CpsInp000+0, "p2 right"},
  {"P2 Shot"       , 0, CpsInp000+4, "p2 fire 1"},
  {"P2 Special"    , 0, CpsInp000+5, "p2 fire 2"},

  {"Reset"         , 0, &CpsReset,   "reset"},
  {"Diagnostic"    , 0, CpsInp018+6, "diag"},
  {"Service"       , 0, CpsInp018+2, "service"},
};

// Return 0 if a input number is defined, and (if pii!=NULL) information about each input
static int DrvInputInfo(struct BurnInputInfo *pii,unsigned int i)
{
  unsigned int nDrvCount=0;
  nDrvCount=sizeof(DrvInputList) /sizeof(DrvInputList[0]);
  if (i<nDrvCount) { if (pii!=NULL) *pii=DrvInputList[i];  return 0; }
  else SETUP_THE_CHEAT_LIST
  else SETUP_THE_DIPSW_LIST
  return 1;
}

static int DrvScode(unsigned int n)
{
  if (n>=0x8f && n<0xad) return 2;
  if (n>=0xc2 && n<0xc3) return 2;
  return 1;
}

static int DrvExit()
{

  DestroyCheatList();
  DestroyDIPSWList();

  CpsRunExit();
  BurnScode=NULL;
  nPsndIrqPeriod=0; //OLDTST
  CpsExit();
  nCpsAdLen=0; nCpsZRomLen=0; nCpsGfxLen=0; nCpsRomLen=0;
  Cps=0;
  return 0;
}

static int DrvFrame()
{

APPLY_CHEATS(CpsRamFF)

  CpsFsStopOpposite(); // stop opposite directions
  // Carry on to CPS frame
  Cps1Frame();
  return 0;
}

//========================
//Carrier Air Wing (World)
//========================

static int CawingInit()
{
  int nRet=0;
  Cps=1;
  nCpsRomLen =  0x100000;
  nCpsCodeLen=0; // not encrypted
  nCpsGfxLen =4*0x080000;
  nCpsZRomLen=  0x010000;
  nCpsAdLen  =2*0x020000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  // Load program roms
  nRet=BurnLoadRom(CpsRom+0x000001,0,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x000000,1,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x040001,2,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x040000,3,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x080000,4,1); if (nRet!=0) return 1; // Already byteswapped
  // Set dip switches
  SETUP_DIPSW_3(Cpi01A,Cpi01C,Cpi01E,0x00,0x03,0x60);
  // Load graphics roms
  CpsLoadTiles(CpsGfx,5);

  nCpsLcReg=0x4c; // Layer control register is at 0x4c
  CpsLayEn[1]=0x10;
  CpsLayEn[2]=0x0a;
  CpsLayEn[3]=0x0a;

  // Start of Board ID improvments by KEV. 0x40,0x0406
  CpsBID[0]=0x40;
  CpsBID[1]=0x04;
  CpsBID[2]=0x06;

  MaskAddr[0]=0x4a;
  MaskAddr[1]=0x48;
  MaskAddr[2]=0x46;
  MaskAddr[3]=0x44;

  // Load Z80 Rom
  nRet=BurnLoadRom(CpsZRom,9,1);
  BurnScode=DrvScode;

  // Load ADPCM data
  nRet=BurnLoadRom(CpsAd        ,10,1);
  nRet=BurnLoadRom(CpsAd+0x20000,11,1);

  nPsndIrqPeriod=(60<<10)/250; //OLDTST

  ConstructCheatList();
  ConstructDIPSWList();
  nRet=CpsRunInit();

  if (nRet!=0) return 1;
  // Ready to go
  return 0;
}

static int CawingZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="cawing.zip"; return 0; }
  return 1;
}

static struct StdRomInfo CawingRomDesc[]=
{
  {"cae_30a.rom" ,0x20000,0x91fceacd, 0x10}, //  0 68000 code
  {"cae_35a.rom" ,0x20000,0x3ef03083, 0x10}, //  1
  {"cae_31a.rom" ,0x20000,0xe5b75caf, 0x10}, //  2 68000 code
  {"cae_36a.rom" ,0x20000,0xc73fd713, 0x10}, //  3
  {"ca_32.rom" ,0x80000,0x0c4837d4, 0x10}, //  4

// 5
  {"ca_gfx5.rom"   ,0x80000,0x66d4cc37,    1},
  {"ca_gfx7.rom"   ,0x80000,0xb6f896f2,    1},
  {"ca_gfx1.rom"   ,0x80000,0x4d0620fd,    1},
  {"ca_gfx3.rom"   ,0x80000,0x0b0341c3,    1},

// 9
// z80 program
  {"ca_9.rom"   ,0x10000,0x96fe7485,    2},
// adpcm samples
  {"ca_18.rom"   ,0x20000,0x4a613a2c,    2},
  {"ca_19.rom"   ,0x20000,0x74584493,    2},
// 18
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Cawing) STD_ROM_FN(Cawing)

struct BurnDriver BurnDrvCpsCawing=
{
  {"cawing","Carrier Air Wing (World)","","Capcom","CPS1","1990",NULL},
  1,2,HARDWARE_CAPCOM_CPS1,
  CawingZipName,CawingRomInfo,CawingRomName,DrvInputInfo,
  CawingInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};


//=================
//U.S. Navy (Japan)
//=================

static int CawingjInit()
{
  int nRet=0;
  Cps=1;
  nCpsRomLen =  0x100000;
  nCpsCodeLen=0; // not encrypted
  nCpsGfxLen =4*0x080000;
  nCpsZRomLen=  0x010000;
  nCpsAdLen  =2*0x020000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  // Load program roms
  nRet=BurnLoadRom(CpsRom+0x000001,0,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x000000,1,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x040001,2,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x040000,3,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x080001,4,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x080000,5,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x0c0001,6,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x0c0000,7,2); if (nRet!=0) return 1;
  // Set dip switches
  SETUP_DIPSW_3(Cpi01A,Cpi01C,Cpi01E,0x00,0x03,0x60);
  // Load graphics roms
  CpsLoadTilesByte(CpsGfx, 8);
  CpsLoadTilesByte(CpsGfx+(8*0x020000), 8+8);

  nCpsLcReg=0x4c; // Layer control register is at 0x4c
  CpsLayEn[1]=0x10; 
  CpsLayEn[2]=0x0a; 
  CpsLayEn[3]=0x0a; 

  // Start of Board ID improvments by KEV. 0x40,0x0406
  CpsBID[0]=0x40;   
  CpsBID[1]=0x04;
  CpsBID[2]=0x06;

  MaskAddr[0]=0x4a;
  MaskAddr[1]=0x48;
  MaskAddr[2]=0x46;
  MaskAddr[3]=0x44;

  // Load Z80 Rom
  nRet=BurnLoadRom(CpsZRom,24,1);
  BurnScode=DrvScode;

  // Load ADPCM data
  nRet=BurnLoadRom(CpsAd        ,25,1);
  nRet=BurnLoadRom(CpsAd+0x20000,26,1);

  nPsndIrqPeriod=(60<<10)/250; //OLDTST

  ConstructCheatList();
  ConstructDIPSWList();

  nRet=CpsRunInit();

  if (nRet!=0) return 1;
  // Ready to go
  return 0;
}

static int CawingjZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="cawing.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="cawingj.zip"; return 0; }
  return 1;
}

static struct StdRomInfo CawingjRomDesc[]=
{
  {"cae_30a.rom" ,0x20000,0x91fceacd, 0x10}, //  0 68000 code
  {"caj42a.bin" ,0x20000,0x039f8362, 0x10}, //  1
  {"cae_31a.rom" ,0x20000,0xe5b75caf, 0x10}, //  2 68000 code
  {"cae_36a.rom" ,0x20000,0xc73fd713, 0x10}, //  3
  {"caj34.bin" ,0x20000,0x51ea57f4, 0x10}, //  4 68000 code
  {"caj40.bin" ,0x20000,0x2ab71ae1, 0x10}, //  5
  {"caj35.bin" ,0x20000,0x01d71973, 0x10}, //  6 68000 code
  {"caj41.bin" ,0x20000,0x3a43b538, 0x10}, //  7

// 8
  {"caj09.bin"   ,0x20000,0x41b0f9a6,    1},
  {"caj01.bin"   ,0x20000,0x1002d0b8,    1},
  {"caj13.bin"   ,0x20000,0x6f3948b2,    1},
  {"caj05.bin"   ,0x20000,0x207373d7,    1},
// 12
  {"caj24.bin"   ,0x20000,0xe356aad7,    1},
  {"caj17.bin"   ,0x20000,0x540f2fd8,    1},
  {"caj38.bin"   ,0x20000,0x2464d4ab,    1},
  {"caj32.bin"   ,0x20000,0x9b5836b3,    1},
// 16
  {"caj10.bin"   ,0x20000,0xbf8a5f52,    1},
  {"caj02.bin"   ,0x20000,0x125b018d,    1},
  {"caj14.bin"   ,0x20000,0x8458e7d7,    1},
  {"caj06.bin"   ,0x20000,0xcf80e164,    1},
// 20
  {"caj25.bin"   ,0x20000,0xcdd0204d,    1},
  {"caj18.bin"   ,0x20000,0x29c1d4b1,    1},
  {"caj39.bin"   ,0x20000,0xeea23b67,    1},
  {"caj33.bin"   ,0x20000,0xdde3891f,    1},
// 24
// z80 program
  {"ca_9.rom"   ,0x10000,0x96fe7485,    2},
// adpcm samples
  {"ca_18.rom"   ,0x20000,0x4a613a2c,    2},
  {"ca_19.rom"   ,0x20000,0x74584493,    2},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Cawingj) STD_ROM_FN(Cawingj)

struct BurnDriver BurnDrvCpsCawingj=
{
  {"cawingj","U.S. Navy (Japan)","","Capcom","CPS1","1990","cawing"},
  1,2,HARDWARE_CAPCOM_CPS1,
  CawingjZipName,CawingjRomInfo,CawingjRomName,DrvInputInfo,
  CawingjInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};
