#include "cps.h"
// Capcom World 2 - All-in-One 1.11 Driver by Mike_Haggar_99@hotmail.com
// Cheat engine source by HyperYagami
// Added Dip A/B/C by Bigfool


static struct BurnInputInfo DrvInputList[]=
{
  {"P1 Coin"       , 0, CpsInp018+0, "p1 coin"},
  {"P1 Start"      , 0, CpsInp018+4, "p1 start"},
  {"P1 Up"         , 0, CpsInp001+3, "p1 up"},
  {"P1 Down"       , 0, CpsInp001+2, "p1 down"},
  {"P1 Left"       , 0, CpsInp001+1, "p1 left"},
  {"P1 Right"      , 0, CpsInp001+0, "p1 right"},
  {"P1 Answer 1"   , 0, CpsInp001+4, "p1 fire 1"},
  {"P1 Answer 2"   , 0, CpsInp001+5, "p1 fire 2"},
  {"P1 Answer 3"   , 0, CpsInp001+6, "p1 fire 3"},
  {"P1 Answer 4"   , 0, CpsInp001+7, "p1 fire 4"},

  {"P2 Coin"       , 0, CpsInp018+1, "p2 coin"},
  {"P2 Start"      , 0, CpsInp018+5, "p2 start"},
  {"P2 Up"         , 0, CpsInp000+3, "p2 up"},
  {"P2 Down"       , 0, CpsInp000+2, "p2 down"},
  {"P2 Left"       , 0, CpsInp000+1, "p2 left"},
  {"P2 Right"      , 0, CpsInp000+0, "p2 right"},
  {"P2 Answer 1"   , 0, CpsInp000+4, "p2 fire 1"},
  {"P2 Answer 2"   , 0, CpsInp000+5, "p2 fire 2"},
  {"P2 Answer 3"   , 0, CpsInp000+6, "p2 fire 3"},
  {"P2 Answer 4"   , 0, CpsInp000+7, "p2 fire 4"},

  {"Reset"         , 0, &CpsReset,   "reset"},
  {"Diagnostic"    , 0, CpsInp018+6, "diag"},
  {"Service"       , 0, CpsInp018+2, "service"},
};

// Return 0 if a input number is defined, and (if pii!=NULL) information about each input
static int DrvInputInfo(struct BurnInputInfo *pii,unsigned int i)
{
  unsigned int nDrvCount=0;
  nDrvCount=sizeof(DrvInputList) /sizeof(DrvInputList[0]);
  if (i<nDrvCount) { if (pii!=NULL) *pii=DrvInputList[i];  return 0; }
  else SETUP_THE_CHEAT_LIST
  else SETUP_THE_DIPSW_LIST
  return 1;
}

static int DrvScode(unsigned int n)
{
  if (n<=0x12) return 2;
  if (n>=0x18 && n<=0x1b) return 2;
  if (n>=0x38 && n<=0x3b) return 2;
  if (n>=0x46 && n<=0x54) return 2;
  if (n==0x56 || n==0x5a || n==0x5d) return 2;
  if (n>=0x71 && n<=0x83) return 2;               // mirror
  if (n>=0x89 && n<=0x8c) return 2;				  // mirror
  if (n>=0xa9 && n<=0xac) return 2;				  // mirror
  if (n>=0xb7 && n<=0xc5) return 2;				  // mirror
  if (n==0xc7 || n==0xcb || n==0xce) return 2;	  // mirror
  if (n>=0xe2 && n<=0xff) return 2;               // mirror 2
  return 1;
}

static int DrvInit()
{
  int nRet=0;
  Cps=1;
  nCpsRomLen=   0x100000;
  nCpsCodeLen=0; // not encrypted
  nCpsGfxLen= 4*0x080000;
  nCpsZRomLen=  0x010000;
  nCpsAdLen  =2*0x020000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  // Load program roms
  nRet=BurnLoadRom(CpsRom+0x000001,0,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x000000,1,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x040001,2,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x040000,3,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x080001,4,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x080000,5,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x0c0001,6,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x0c0000,7,2); if (nRet!=0) return 1;
  // Set dip switches
  SETUP_DIPSW_3(Cpi01A,Cpi01C,Cpi01E,0x00,0x03,0x60);
  // Load graphics roms
  CpsLoadTilesByte(CpsGfx, 8);
  CpsLoadTilesByte(CpsGfx+(8*0x020000), 8+8);

  nCpsLcReg=0x60; // Layer control register is at 0x60
  CpsLayEn[1]=0x20;
  CpsLayEn[2]=0x14;
  CpsLayEn[3]=0x14;

  // Protection enable code by KEV
  CpsMProt[0]=0x00;
  CpsMProt[1]=0x00;
  CpsMProt[2]=0x00;
  CpsMProt[3]=0x00;

  MaskAddr[0]=0x6e;
  MaskAddr[1]=0x6c;
  MaskAddr[2]=0x6a;
  MaskAddr[3]=0x68;

  // Load Z80 Rom
  nRet=BurnLoadRom(CpsZRom,24,1);
  nPsndIrqPeriod=(60<<10)/250; //OLDTST
  BurnScode=DrvScode;

  // Load ADPCM data
  nRet=BurnLoadRom(CpsAd        ,25,1);
  nRet=BurnLoadRom(CpsAd+0x20000,26,1);

  ConstructCheatList();
  ConstructDIPSWList();

  nRet=CpsRunInit(); if (nRet!=0) return 1;
  // Ready to go
  return 0;
}

static int DrvExit()
{

  // HyperYagami: cheats
  DestroyCheatList();
  DestroyDIPSWList();

  CpsRunExit();
  BurnScode=NULL;
  nPsndIrqPeriod=0; //OLDTST

  CpsExit();
  nCpsAdLen=0; nCpsZRomLen=0; nCpsGfxLen=0; nCpsRomLen=0;
  Cps=0;
  return 0;
}

static int DrvFrame()
{

  // HyperYagami: cheats
APPLY_CHEATS(CpsRamFF)

  CpsFsStopOpposite(); // stop opposite directions
  // Carry on to CPS frame
  Cps1Frame();
  return 0;
}

//======================
//Capcom World 2 (Japan)
//======================

// Count possible zip names and (if pszName!=NULL) return them
static int Cworld2jZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="cworld2j.zip"; return 0; }
  return 1;
}

// Rom information
static struct StdRomInfo Cworld2jRomDesc[]=
{
  {"q536.bin" ,0x20000,0x38a08099,0x10}, // 0 even 68000 code
  {"q542.bin" ,0x20000,0x4d29b3a4,0x10}, // 1 odd
  {"q537.bin" ,0x20000,0xeb547ebc,0x10}, // 2 even
  {"q543.bin" ,0x20000,0x3ef65ea8,0x10}, // 3 odd
  {"q534.bin" ,0x20000,0x7fcc1317,0x10}, // 4 even 68000 code
  {"q540.bin" ,0x20000,0x7f14b7b4,0x10}, // 5 odd
  {"q535.bin" ,0x20000,0xabacee26,0x10}, // 6 even
  {"q541.bin" ,0x20000,0xd3654067,0x10}, // 7 odd

  // graphics:
  {"q509.bin",0x20000,0x48496d80,   1}, // 8
  {"q501.bin",0x20000,0xc5453f56,   1},
  {"q513.bin",0x20000,0xc741ac52,   1},
  {"q505.bin",0x20000,0x143e068f,   1},
  {"q524.bin",0x20000,0xb419d139,   1}, // 12
  {"q517.bin",0x20000,0xbd3b4d11,   1},
  {"q538.bin",0x20000,0x9c24670c,   1},
  {"q532.bin",0x20000,0x3ef9c7c2,   1},
  {"q510.bin",0x20000,0x119e5e93,   1}, // 16
  {"q502.bin",0x20000,0xa2cadcbe,   1},
  {"q514.bin",0x20000,0xa8755f82,   1},
  {"q506.bin",0x20000,0xc92a91fc,   1},
  {"q525.bin",0x20000,0x979237cb,   1}, // 20
  {"q518.bin",0x20000,0xc57da03c,   1},
  {"q539.bin",0x20000,0xa5839b25,   1},
  {"q533.bin",0x20000,0x04d03930,   1},

  // z80 rom
  {"q523.bin" ,0x10000,0xe14dc524,   1}, // 24
  // samples
  {"q530.bin" ,0x20000,0xd10c1b68,   1},
  {"q531.bin" ,0x20000,0x7d17e496,   1},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Cworld2j) STD_ROM_FN(Cworld2j)

struct BurnDriver BurnDrvCpsCworld2j=
{
  {"cworld2j","Capcom World 2 (Japan)","","Capcom","CPS1","1992",NULL},
  1,2,HARDWARE_CAPCOM_CPS1,
  Cworld2jZipName,Cworld2jRomInfo,Cworld2jRomName,DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};
