#include "cps.h"
// CPS1 - Driver

static unsigned char AllThreeA[4]={0,0,0,0};

// Inputs common to all Cps2 Fighter Style games (3 x Punch,3 x Kick)
struct BurnInputInfo CpsOneFsi[30]=
{
  {"P1 Coin"       , 0, CpsInp018+0, "p1 coin"   },
  {"P1 Start"      , 0, CpsInp018+4, "p1 start"  },
  {"P1 Up"         , 0, CpsInp001+3, "p1 up"     },
  {"P1 Down"       , 0, CpsInp001+2, "p1 down"   },
  {"P1 Left"       , 0, CpsInp001+1, "p1 left"   },
  {"P1 Right"      , 0, CpsInp001+0, "p1 right"  },
  {"P1 Low Punch"  , 0, CpsInp001+4, "p1 fire 4" },
  {"P1 Mid Punch"  , 0, CpsInp001+5, "p1 fire 5" },
  {"P1 High Punch" , 0, CpsInp001+6, "p1 fire 6" },
  {"P1 Low Kick"   , 0, CpsInp177+0, "p1 fire 1" },
  {"P1 Mid Kick"   , 0, CpsInp177+1, "p1 fire 2" },
  {"P1 High Kick"  , 0, CpsInp177+2, "p1 fire 3" },
  {"P1 All Punches", 0, AllThreeA+0 , ""         },
  {"P1 All Kicks"  , 0, AllThreeA+1 , ""         },
  {"P2 Coin"       , 0, CpsInp018+1, "p2 coin"   },
  {"P2 Start"      , 0, CpsInp018+5, "p2 start"  },
  {"P2 Up"         , 0, CpsInp000+3, "p2 up"     },
  {"P2 Down"       , 0, CpsInp000+2, "p2 down"   },
  {"P2 Left"       , 0, CpsInp000+1, "p2 left"   },
  {"P2 Right"      , 0, CpsInp000+0, "p2 right"  },
  {"P2 Low Punch"  , 0, CpsInp000+4, "p2 fire 4" },
  {"P2 Mid Punch"  , 0, CpsInp000+5, "p2 fire 5" },
  {"P2 High Punch" , 0, CpsInp000+6, "p2 fire 6" },
  {"P2 Low Kick"   , 0, CpsInp177+4, "p2 fire 1" },
  {"P2 Mid Kick"   , 0, CpsInp177+5, "p2 fire 2" },
  {"P2 High Kick"  , 0, CpsInp177+6, "p2 fire 3" },
  {"P2 All Punches", 0, AllThreeA+2 , ""         },
  {"P2 All Kicks"  , 0, AllThreeA+3 , ""         },
  {"Reset"         , 0, &CpsReset  , "reset"     },
  {"Diagnostic"    , 0, CpsInp018+6, "diag"      },
};

int CpsOneFsAllThree()
{
  // Process all three punches and kicks
  if (AllThreeA[0]) { CpsOneFsi[ 6].pVal[0]=1; CpsOneFsi[ 7].pVal[0]=1; CpsOneFsi[ 8].pVal[0]=1; }
  if (AllThreeA[1]) { CpsOneFsi[ 9].pVal[0]=1; CpsOneFsi[10].pVal[0]=1; CpsOneFsi[11].pVal[0]=1; }
  if (AllThreeA[2]) { CpsOneFsi[20].pVal[0]=1; CpsOneFsi[21].pVal[0]=1; CpsOneFsi[22].pVal[0]=1; }
  if (AllThreeA[3]) { CpsOneFsi[23].pVal[0]=1; CpsOneFsi[24].pVal[0]=1; CpsOneFsi[25].pVal[0]=1; }
  return 0;
}
