#include "cps.h"

/*============================================================
 Mercs - All-in-One 1.33 Driver by Mike_Haggar_99@hotmail.com
 Partial Fix Player 3 Controls by Bigfool
 Corrected Player 3 Controls - Treble Winner
 Cheat engine source by HyperYagami
 Added hardware description flag & tidied up a bit - Loop
============================================================*/

static struct BurnInputInfo DrvInputList[]=
{
  {"P1 Coin"       , 0, CpsInp018+0, "p1 coin"  },
  {"P1 Start"      , 0, CpsInp018+4, "p1 start" },
  {"P1 Up"         , 0, CpsInp001+3, "p1 up"    },
  {"P1 Down"       , 0, CpsInp001+2, "p1 down"  },
  {"P1 Left"       , 0, CpsInp001+1, "p1 left"  },
  {"P1 Right"      , 0, CpsInp001+0, "p1 right" },
  {"P1 Shot"       , 0, CpsInp001+4, "p1 fire 1"},
  {"P1 Special"    , 0, CpsInp001+5, "p1 fire 2"},

  {"P2 Coin"       , 0, CpsInp018+1, "p2 coin"  },
  {"P2 Start"      , 0, CpsInp018+5, "p2 start" },
  {"P2 Up"         , 0, CpsInp000+3, "p2 up"    },
  {"P2 Down"       , 0, CpsInp000+2, "p2 down"  },
  {"P2 Left"       , 0, CpsInp000+1, "p2 left"  },
  {"P2 Right"      , 0, CpsInp000+0, "p2 right" },
  {"P2 Shot"       , 0, CpsInp000+4, "p2 fire 1"},
  {"P2 Special"    , 0, CpsInp000+5, "p2 fire 2"},

  {"P3 Coin"       , 0, CpsInp177+6, "p3 coin"  },
  {"P3 Start"      , 0, CpsInp177+7, "p3 start" },
  {"P3 Up"         , 0, CpsInp177+3, "p3 up"    },
  {"P3 Down"       , 0, CpsInp177+2, "p3 down"  },
  {"P3 Left"       , 0, CpsInp177+1, "p3 left"  },
  {"P3 Right"      , 0, CpsInp177+0, "p3 right" },
  {"P3 Shot"       , 0, CpsInp177+4, "p3 fire 1"},
  {"P3 Special"    , 0, CpsInp177+5, "p3 fire 2"},

  {"Reset"         , 0, &CpsReset,   "reset"    },
  {"Diagnostic"    , 0, CpsInp018+6, "diag"     },
  {"Service"       , 0, CpsInp018+2, "service"  },
};
// Return 0 if a input number is defined, and (if pii!=NULL) information about each input
static int DrvInputInfo(struct BurnInputInfo *pii,unsigned int i)
{
  unsigned int nDrvCount=0;
  nDrvCount=sizeof(DrvInputList) /sizeof(DrvInputList[0]);
  if (i<nDrvCount) { if (pii!=NULL) *pii=DrvInputList[i];  return 0; }
  else SETUP_THE_CHEAT_LIST
  else SETUP_THE_DIPSW_LIST
  return 1;
}

static int DrvScode(unsigned int n)
{
  if (n<=0x11) return 2;
  if (n>=0x5a && n<=0x6b) return 2;
  return 1;
}

static int DrvInit()
{
  int nRet=0;
  nRet=RotInit(); if (nRet!=0) return 1;
  Cps=1; Mercs=1;
  nCpsRomLen=   0x100000;
  nCpsCodeLen=0; // not encrypted
  nCpsGfxLen= 6*0x080000;
  nCpsZRomLen=  0x010000;
  nCpsAdLen  =2*0x020000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  // Load program roms
  nRet=BurnLoadRom(CpsRom+0x000001,0,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x000000,1,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x040001,2,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x040000,3,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x080000,4,1); if (nRet!=0) return 1;
  // Set dip switches
  SETUP_DIPSW_3(Cpi01A,Cpi01C,Cpi01E,0x00,0x03,0x60);
  // Load graphics roms
  CpsLoadTiles(CpsGfx         ,5);
  CpsLoadTilesByte(CpsGfx+0x200000,9);

  nCpsLcReg=0x6c; // Layer control register is at 0x70
  CpsLayEn[1]=0x02;
  CpsLayEn[2]=0x04;
  CpsLayEn[3]=0x08;

  // Start of Board ID improvments by KEV. 0x60,0x0402
  CpsBID[0]=0x60;
  CpsBID[1]=0x04;
  CpsBID[2]=0x02;

  StartScroll[SCROLL_2]=0x0600;
  EndScroll[SCROLL_2]=0x5bff;
  StartScroll[SCROLL_3]=0x0700;
  EndScroll[SCROLL_3]=0x17ff;

  // Load Z80 Rom
  nRet=BurnLoadRom(CpsZRom,17,1);
  nPsndIrqPeriod=(60<<10)/250; //OLDTST
  BurnScode=DrvScode;

  // Load ADPCM data
  nRet=BurnLoadRom(CpsAd        ,18,1);
  nRet=BurnLoadRom(CpsAd+0x20000,19,1);

  ConstructCheatList();
  ConstructDIPSWList();

  nRet=CpsRunInit(); if (nRet!=0) return 1;
  // Ready to go
  return 0;
}

static int DrvExit()
{

  DestroyCheatList();
  DestroyDIPSWList();

  CpsRunExit();
  BurnScode=NULL;
  nPsndIrqPeriod=0; //OLDTST

  StartScroll[SCROLL_2]=0;
  EndScroll[SCROLL_2]=0xffff;
  StartScroll[SCROLL_3]=0;
  EndScroll[SCROLL_3]=0xffff;

  CpsExit();
  RotExit();
  nCpsAdLen=0; nCpsZRomLen=0; nCpsGfxLen=0; nCpsRomLen=0;
  Cps=0; Mercs=0;
  return 0;
}

static int DrvFrame()
{

  // HyperYagami: cheats
APPLY_CHEATS(CpsRamFF)

  RotStart();
  CpsFsStopOpposite(); // stop opposite directions
  ONLY_ONE(177,0,1) ONLY_ONE(177,2,3) // Input Port 177

  // Carry on to CPS frame
  Cps1Frame();
  RotStop();
  return 0;
}

/*=============
 Mercs (World)
=============*/

static int MercsZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="mercs.zip"; return 0; }
  return 1;
}

static struct StdRomInfo MercsRomDesc[]=
{
  {"so2_30e.rom" ,0x20000,0xe17f9bf7,0x10}, // 0 even 68000 code
  {"so2_35e.rom" ,0x20000,0x78e63575,0x10}, // 1 odd
  {"so2_31e.rom" ,0x20000,0x51204d36,0x10}, // 2 even
  {"so2_36e.rom" ,0x20000,0x9cfba8b4,0x10}, // 3 odd
  {"so2_32.rom"  ,0x80000,0x2eb5cf0c,0x10}, // 4 swapped

  {"so2_gfx6.rom",0x80000,0xaa6102af,   1}, // 5
  {"so2_gfx8.rom",0x80000,0x839e6869,   1},
  {"so2_gfx2.rom",0x80000,0x597c2875,   1},
  {"so2_gfx4.rom",0x80000,0x912a9ca0,   1},

  {"so2_24.rom"  ,0x20000,0x3f254efe,   1}, // 9
  {"so2_14.rom"  ,0x20000,0xf5a8905e,   1},
  {"so2_26.rom"  ,0x20000,0xf3aa5a4a,   1},
  {"so2_16.rom"  ,0x20000,0xb43cd1a8,   1},

  {"so2_20.rom"  ,0x20000,0x8ca751a3,   1}, // 13
  {"so2_10.rom"  ,0x20000,0xe9f569fd,   1},
  {"so2_22.rom"  ,0x20000,0xfce9a377,   1},
  {"so2_12.rom"  ,0x20000,0xb7df8a06,   1},

  {"so2_09.rom"  ,0x10000,0xd09d7c7a,   1}, // 17

  {"so2_18.rom"  ,0x20000,0xbbea1643,   1},
  {"so2_19.rom"  ,0x20000,0xac58aa71,   1},
};

STD_ROM_PICK(Mercs) STD_ROM_FN(Mercs)

struct BurnDriver BurnDrvCpsMercs=
{
  {"mercs","Mercs (World)","","Capcom","CPS1","1990",NULL},
  1,3,HARDWARE_CAPCOM_CPS1,
  MercsZipName,MercsRomInfo,MercsRomName,DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,224,384,3,4
};

/*===========
 Mercs (USA)
===========*/

static int MercsuZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="mercs.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="mercsu.zip"; return 0; }
  return 1;
}

static struct StdRomInfo MercsuRomDesc[]=
{
  {"so2_30e.rom" ,0x20000,0xe17f9bf7,0x10}, // 0 even 68000 code
  {"s02-35"      ,0x20000,0x4477df61,0x10}, // 1 odd
  {"so2_31e.rom" ,0x20000,0x51204d36,0x10}, // 2 even
  {"so2_36e.rom" ,0x20000,0x9cfba8b4,0x10}, // 3 odd
  {"so2_32.rom"  ,0x80000,0x2eb5cf0c,0x10}, // 4 swapped

  {"so2_gfx6.rom",0x80000,0xaa6102af,   1}, // 5
  {"so2_gfx8.rom",0x80000,0x839e6869,   1},
  {"so2_gfx2.rom",0x80000,0x597c2875,   1},
  {"so2_gfx4.rom",0x80000,0x912a9ca0,   1},

  {"so2_24.rom"  ,0x20000,0x3f254efe,   1}, // 9
  {"so2_14.rom"  ,0x20000,0xf5a8905e,   1},
  {"so2_26.rom"  ,0x20000,0xf3aa5a4a,   1},
  {"so2_16.rom"  ,0x20000,0xb43cd1a8,   1},

  {"so2_20.rom"  ,0x20000,0x8ca751a3,   1}, // 13
  {"so2_10.rom"  ,0x20000,0xe9f569fd,   1},
  {"so2_22.rom"  ,0x20000,0xfce9a377,   1},
  {"so2_12.rom"  ,0x20000,0xb7df8a06,   1},

  {"so2_09.rom"  ,0x10000,0xd09d7c7a,   1}, // 17

  {"so2_18.rom"  ,0x20000,0xbbea1643,   1},
  {"so2_19.rom"  ,0x20000,0xac58aa71,   1},
};

STD_ROM_PICK(Mercsu) STD_ROM_FN(Mercsu)

struct BurnDriver BurnDrvCpsMercsu=
{
  {"mercsu","Mercs (USA)","","Capcom","CPS1","1990","mercs"},
  1,3,HARDWARE_CAPCOM_CPS1,
  MercsuZipName,MercsuRomInfo,MercsuRomName,DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,224,384,3,4
};

/*=============
 Mercs (Japan)
=============*/

static int MercsjZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="mercs.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="mercsj.zip"; return 0; }
  return 1;
}

static struct StdRomInfo MercsjRomDesc[]=
{
  {"so2_30e.rom" ,0x20000,0xe17f9bf7,0x10}, // 0 even 68000 code
  {"so2_42.bin"  ,0x20000,0x2c3884c6,0x10}, // 1 odd
  {"so2_31e.rom" ,0x20000,0x51204d36,0x10}, // 2 even
  {"so2_36e.rom" ,0x20000,0x9cfba8b4,0x10}, // 3 odd
  {"so2_32.rom"  ,0x80000,0x2eb5cf0c,0x10}, // 4 swapped

  {"so2_gfx6.rom",0x80000,0xaa6102af,   1}, // 5
  {"so2_gfx8.rom",0x80000,0x839e6869,   1},
  {"so2_gfx2.rom",0x80000,0x597c2875,   1},
  {"so2_gfx4.rom",0x80000,0x912a9ca0,   1},

  {"so2_24.rom"  ,0x20000,0x3f254efe,   1}, // 9
  {"so2_14.rom"  ,0x20000,0xf5a8905e,   1},
  {"so2_26.rom"  ,0x20000,0xf3aa5a4a,   1},
  {"so2_16.rom"  ,0x20000,0xb43cd1a8,   1},

  {"so2_20.rom"  ,0x20000,0x8ca751a3,   1}, // 13
  {"so2_10.rom"  ,0x20000,0xe9f569fd,   1},
  {"so2_22.rom"  ,0x20000,0xfce9a377,   1},
  {"so2_12.rom"  ,0x20000,0xb7df8a06,   1},

  {"so2_09.rom"  ,0x10000,0xd09d7c7a,   1}, // 17

  {"so2_18.rom"  ,0x20000,0xbbea1643,   1}, 
  {"so2_19.rom"  ,0x20000,0xac58aa71,   1},
};

STD_ROM_PICK(Mercsj) STD_ROM_FN(Mercsj)

struct BurnDriver BurnDrvCpsMercsj=
{
  {"mercsj","Senjo no Ookami II (Japan)","","Capcom","CPS1","1990","mercs"},
  1,3,HARDWARE_CAPCOM_CPS1,
  MercsjZipName,MercsjRomInfo,MercsjRomName,DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,224,384,3,4
};