#include "cps.h"
// Nemo - All-in-One Driver 1.21 by Mike_Haggar_99@hotmail.com
// Load menu display adjustment by LoopMaster
// Cheat engine source by HyperYagami
// Added Dip A/B/C by Bigfool


static struct BurnInputInfo DrvInputList[]=
{
  {"P1 Coin"       , 0, CpsInp018+0, "p1 coin"  },
  {"P1 Start"      , 0, CpsInp018+4, "p1 start" },
  {"P1 Up"         , 0, CpsInp001+3, "p1 up"    },
  {"P1 Down"       , 0, CpsInp001+2, "p1 down"  },
  {"P1 Left"       , 0, CpsInp001+1, "p1 left"  },
  {"P1 Right"      , 0, CpsInp001+0, "p1 right" },
  {"P1 Attack"     , 0, CpsInp001+4, "p1 fire 1"},
  {"P1 Jump"       , 0, CpsInp001+5, "p1 fire 2"},

  {"P2 Coin"       , 0, CpsInp018+1, "p2 coin"  },
  {"P2 Start"      , 0, CpsInp018+5, "p2 start" },
  {"P2 Up"         , 0, CpsInp000+3, "p2 up"    },
  {"P2 Down"       , 0, CpsInp000+2, "p2 down"  },
  {"P2 Left"       , 0, CpsInp000+1, "p2 left"  },
  {"P2 Right"      , 0, CpsInp000+0, "p2 right" },
  {"P2 Attack"     , 0, CpsInp000+4, "p2 fire 1"},
  {"P2 Jump"       , 0, CpsInp000+5, "p2 fire 2"},

  {"Reset"         , 0, &CpsReset,   "reset"    },
  {"Diagnostic"    , 0, CpsInp018+6, "diag"     },
  {"Service"       , 0, CpsInp018+2, "service"},
};

// Return 0 if a input number is defined, and (if pii!=NULL) information about each input
static int DrvInputInfo(struct BurnInputInfo *pii,unsigned int i)
{
  unsigned int nDrvCount=0;
  nDrvCount=sizeof(DrvInputList) /sizeof(DrvInputList[0]);
  if (i<nDrvCount) { if (pii!=NULL) *pii=DrvInputList[i];  return 0; }
  else SETUP_THE_CHEAT_LIST
  else SETUP_THE_DIPSW_LIST
  return 1;
}

static int DrvScode(unsigned int n)
{
  if (n<=0x1d) return 2;
  if (n>=0x5c && n<=0x5d) return 2;
  if (n>=0x64 && n<=0x65) return 2;
  if (n>=0x6e && n<=0x6f) return 2;
  if (n>=0x78 && n<=0x95) return 2;
  return 1;
}

static int DrvInit()
{
  int nRet=0;
  Cps=1;
  nCpsRomLen=   0x100000;
  nCpsCodeLen=0; // not encrypted
  nCpsGfxLen= 4*0x080000;
  nCpsZRomLen=  0x010000;
  nCpsAdLen  =2*0x020000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  // Load program roms
  nRet=BurnLoadRom(CpsRom+0x000001,0,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x000000,1,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x040001,2,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x040000,3,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x080000,4,1); if (nRet!=0) return 1; // Already byteswapped

  // Set dip switches
  SETUP_DIPSW_3(Cpi01A,Cpi01C,Cpi01E,0x00,0x03,0x60);

  // Load graphics roms
  CpsLoadTiles(CpsGfx,5);

  nCpsLcReg=0x42; // Layer control register is at 0x42
  CpsLayEn[1]=0x04;
  CpsLayEn[2]=0x22;
  CpsLayEn[3]=0x22;

  // Start of Board ID improvments by KEV. 0x4e,0x0405
  CpsBID[0]=0x4e;
  CpsBID[1]=0x04;
  CpsBID[2]=0x05;

  MaskAddr[0]=0x44;
  MaskAddr[1]=0x46;
  MaskAddr[2]=0x48;
  MaskAddr[3]=0x4a;

  // Load Z80 Rom
  nRet=BurnLoadRom(CpsZRom,9,1);
  nPsndIrqPeriod=(60<<10)/250; //OLDTST
  BurnScode=DrvScode;

  // Load ADPCM data
  nRet=BurnLoadRom(CpsAd        ,10,1);
  nRet=BurnLoadRom(CpsAd+0x20000,11,1);

  ConstructCheatList();
  ConstructDIPSWList();

  nRet=CpsRunInit(); if (nRet!=0) return 1;
  // Ready to go
  return 0;
}

static int DrvExit()
{

  DestroyCheatList();
  DestroyDIPSWList();

  CpsRunExit();
  BurnScode=NULL;
  nPsndIrqPeriod=0; //OLDTST

  CpsExit();
  nCpsAdLen=0; nCpsZRomLen=0; nCpsGfxLen=0; nCpsRomLen=0;
  Cps=0;
  return 0;
}

static int DrvFrame()
{
  // HyperYagami: cheats
APPLY_CHEATS(CpsRamFF)

  CpsFsStopOpposite(); // stop opposite directions
  // Carry on to CPS frame
  Cps1Frame();
  return 0;
}

//============
//Nemo (World)
//============

// Count possible zip names and (if pszName!=NULL) return them
static int NemoZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="nemo.zip"; return 0; }
  return 1;
}

// Rom information
static struct StdRomInfo NemoRomDesc[]=
{
  {"nme_30a.rom" ,0x20000,0xd2c03e56,0x10}, // 0 even 68000 code
  {"nme_35a.rom" ,0x20000,0x5fd31661,0x10}, // 1 odd
  {"nme_31a.rom" ,0x20000,0xb2bd4f6f,0x10}, // 2 even
  {"nme_36a.rom" ,0x20000,0xee9450e3,0x10}, // 3 odd
  {"nm_32.rom",0x80000,0xd6d1add3,0x10}, // 4 both

  // graphics:
  {"nm_gfx5.rom",0x80000,0x487b8747,   1}, // 5
  {"nm_gfx7.rom",0x80000,0x203dc8c6,   1},
  {"nm_gfx1.rom",0x80000,0x9e878024,   1},
  {"nm_gfx3.rom",0x80000,0xbb01e6b6,   1},

  // z80 rom
  {"nm_09.rom" ,0x10000,0x0f4b0581,   1}, // 9
  // samples
  {"nm_18.rom" ,0x20000,0xbab333d4,   1},
  {"nm_19.rom" ,0x20000,0x2650a0a8,   1},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Nemo) STD_ROM_FN(Nemo)

struct BurnDriver BurnDrvCpsNemo=
{
  {"nemo","Nemo (World)","","Capcom","CPS1","1990",NULL},
  1,2,HARDWARE_CAPCOM_CPS1,
  NemoZipName,NemoRomInfo,NemoRomName,DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

//============
//Nemo (Japan)
//============

// Count possible zip names and (if pszName!=NULL) return them
static int NemojZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="nemo.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="nemoj.zip"; return 0; }
  return 1;
}

// Rom information
static struct StdRomInfo NemojRomDesc[]=
{
  {"nm36.bin" ,0x20000,0xdaeceabb,0x10}, // 0 even 68000 code
  {"nm42.bin" ,0x20000,0x55024740,0x10}, // 1 odd
  {"nm37.bin" ,0x20000,0x619068b6,0x10}, // 2 even
  {"nm43.bin" ,0x20000,0xa948a53b,0x10}, // 3 odd
  {"nm_32.rom",0x80000,0xd6d1add3,0x10}, // 4 both

  // graphics:
  {"nm_gfx5.rom",0x80000,0x487b8747,   1}, // 5
  {"nm_gfx7.rom",0x80000,0x203dc8c6,   1},
  {"nm_gfx1.rom",0x80000,0x9e878024,   1},
  {"nm_gfx3.rom",0x80000,0xbb01e6b6,   1},

  // z80 rom
  {"nm_09.rom" ,0x10000,0x0f4b0581,   1}, // 9
  // samples
  {"nm_18.rom" ,0x20000,0xbab333d4,   1},
  {"nm_19.rom" ,0x20000,0x2650a0a8,   1},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Nemoj) STD_ROM_FN(Nemoj)

struct BurnDriver BurnDrvCpsNemoj=
{
  {"nemoj","Nemo (Japan)","","Capcom","CPS1","1990","nemo"},
  1,2,HARDWARE_CAPCOM_CPS1,
  NemojZipName,NemojRomInfo,NemojRomName,DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};
