#include "cps.h"
// Strider (Hiryu) - All-in-One Driver 1.31 by Mike_Haggar_99@hotmail.com
// Load menu display adjustment by LoopMaster
// Cheat engine source by HyperYagami
// Added Dip A/B/C by Bigfool


static struct BurnInputInfo DrvInputList[]=
{
  {"P1 Coin"       , 0, CpsInp018+0, "p1 coin"},
  {"P1 Start"      , 0, CpsInp018+4, "p1 start"},
  {"P1 Up"         , 0, CpsInp001+3, "p1 up"},
  {"P1 Down"       , 0, CpsInp001+2, "p1 down"},
  {"P1 Left"       , 0, CpsInp001+1, "p1 left"},
  {"P1 Right"      , 0, CpsInp001+0, "p1 right"},
  {"P1 Attack"     , 0, CpsInp001+4, "p1 fire 1"},
  {"P1 Jump"       , 0, CpsInp001+5, "p1 fire 2"},

  {"P2 Coin"       , 0, CpsInp018+1, "p2 coin"},
  {"P2 Start"      , 0, CpsInp018+5, "p2 start"},
  {"P2 Up"         , 0, CpsInp000+3, "p2 up"},
  {"P2 Down"       , 0, CpsInp000+2, "p2 down"},
  {"P2 Left"       , 0, CpsInp000+1, "p2 left"},
  {"P2 Right"      , 0, CpsInp000+0, "p2 right"},
  {"P2 Attack"     , 0, CpsInp000+4, "p2 fire 1"},
  {"P2 Jump"       , 0, CpsInp000+5, "p2 fire 2"},

  {"Reset"         , 0, &CpsReset,   "reset"},
  {"Diagnostic"    , 0, CpsInp018+6, "diag"},
  {"Service"       , 0, CpsInp018+2, "service"},
};

// Return 0 if a input number is defined, and (if pii!=NULL) information about each input
static int DrvInputInfo(struct BurnInputInfo *pii,unsigned int i)
{
  unsigned int nDrvCount=0;
  nDrvCount=sizeof(DrvInputList) /sizeof(DrvInputList[0]);
  if (i<nDrvCount) { if (pii!=NULL) *pii=DrvInputList[i];  return 0; }
  else SETUP_THE_CHEAT_LIST
  else SETUP_THE_DIPSW_LIST
  return 1;
}

static int DrvScode(unsigned int n)
{
  if (n<=0x2f) return 2; // music
  if (n<=0x77) return 1; // effects
  if (n<=0x7f) return 2; // music mirror
  if (n<=0xef) return 1; // speech
  return 0; // control codes
}

static int DrvExit()
{
  DestroyCheatList();
  DestroyDIPSWList();
  CpsRunExit();
  BurnScode=NULL;
  nPsndIrqPeriod=0; //OLDTST

  CpsExit();
  nCpsAdLen=0; nCpsZRomLen=0; nCpsGfxLen=0; nCpsRomLen=0;
  Cps=0;
  return 0;
}

static int DrvFrame()
{
  // HyperYagami: cheats
APPLY_CHEATS(CpsRamFF)

  CpsFsStopOpposite(); // stop opposite directions
  // Carry on to CPS frame
  Cps1Frame();
  return 0;
}

// ===========================
// Strider (USA + Japan Set 2)
// ===========================

static int StriderInit()
{
  int nRet=0;
  Cps=1;
  nCpsRomLen=   0x100000;
  nCpsCodeLen=0; // not encrypted
  nCpsGfxLen=   0x400000+0x4000;
  nCpsZRomLen=  0x010000;
  nCpsAdLen  =2*0x020000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  // Load program roms
  nRet=BurnLoadRom(CpsRom+0x000001,0,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x000000,1,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x040001,2,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x040000,3,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x080000,4,1); if (nRet!=0) return 1; // Already byteswapped
  // Set dip switches
  SETUP_DIPSW_3(Cpi01A,Cpi01C,Cpi01E,0x00,0x03,0x60);
  // Load graphics roms
  CpsLoadTiles(CpsGfx         ,5);
  CpsLoadTiles(CpsGfx+0x200000,9);

  // Offset to Scroll tiles
  nCpsGfxScroll[1]=0x200000;
  nCpsGfxScroll[3]=0x200000;

  MaskAddr[0]=0x68;
  MaskAddr[1]=0x6a;
  MaskAddr[2]=0x6c;
  MaskAddr[3]=0x6e;

  // Load Z80 Rom
  nRet=BurnLoadRom(CpsZRom,13,1);
  nPsndIrqPeriod=(60<<10)/500; //OLDTST
  BurnScode=DrvScode;

  // Load ADPCM data
  nRet=BurnLoadRom(CpsAd        ,14,1);
  nRet=BurnLoadRom(CpsAd+0x20000,15,1);

  ConstructCheatList();
  ConstructDIPSWList();

  nRet=CpsRunInit(); if (nRet!=0) return 1;
  // Ready to go
  return 0;
}

// =============
// Strider (USA)
// =============

// Count possible zip names and (if pszName!=NULL) return them
static int StriderZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="strider.zip"; return 0; }
  return 1;
}

// Rom information
static struct StdRomInfo StriderRomDesc[]=
{
  {"strider.30"  ,0x20000,0xda997474,0x10}, // 0 even 68000 code
  {"strider.35"  ,0x20000,0x5463aaa3,0x10}, // 1 odd
  {"strider.31"  ,0x20000,0xd20786db,0x10}, // 2 even
  {"strider.36"  ,0x20000,0x21aa2863,0x10}, // 3 odd
  {"strider.32"  ,0x80000,0x9b3cfc08,0x10}, // 4 both

  // graphics:
  {"strider.06"  ,0x80000,0x4eee9aea,   1}, // 5
  {"strider.08"  ,0x80000,0x2d7f21e4,   1},
  {"strider.02"  ,0x80000,0x7705aa46,   1},
  {"strider.04"  ,0x80000,0x5b18b722,   1},
  {"strider.05"  ,0x80000,0x005f000b,   1}, // 9
  {"strider.07"  ,0x80000,0xb9441519,   1},
  {"strider.01"  ,0x80000,0xb7d04e8b,   1},
  {"strider.03"  ,0x80000,0x6b4713b4,   1},

  // z80 rom
  {"strider.09"  ,0x10000,0x2ed403bc,   1}, // 13
  // samples
  {"strider.18"  ,0x20000,0x4386bc80,   1},
  {"strider.19"  ,0x20000,0x444536d7,   1},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Strider) STD_ROM_FN(Strider)

struct BurnDriver BurnDrvCpsStrider=
{
  {"strider","Strider (USA)","","Capcom","CPS1","1989",NULL},
  1,2,HARDWARE_CAPCOM_CPS1,
  StriderZipName,StriderRomInfo,StriderRomName,DrvInputInfo,
  StriderInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

// ===========================
// Strider Hiryu (Japan Set 1)
// ===========================

static int StriderjInit()
{
  int nRet=0;
  Cps=1;
  nCpsRomLen=   0x100000;
  nCpsCodeLen=0; // not encrypted
  nCpsGfxLen=   0x400000;
  nCpsZRomLen=  0x010000;
  nCpsAdLen  =2*0x020000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  // Load program roms
  nRet=BurnLoadRom(CpsRom+0x000000,0,1); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x080000,1,1); if (nRet!=0) return 1; // Already byteswapped
  // Set dip switches
  SETUP_DIPSW_3(Cpi01A,Cpi01C,Cpi01E,0x00,0x03,0x60);

  // Load graphics roms
  CpsLoadTiles(CpsGfx         ,2);
  CpsLoadTiles(CpsGfx+0x200000,6);
  // Offset to Scroll tiles
  nCpsGfxScroll[1]=0x200000;
  nCpsGfxScroll[3]=0x200000;

  // Enable starfield layers
  CpsLayEn[4]=0x10;
  CpsLayEn[5]=0x20;

  MaskAddr[0]=0x68;
  MaskAddr[1]=0x6a;
  MaskAddr[2]=0x6c;
  MaskAddr[3]=0x6e;

  // Load Z80 Rom
  nRet=BurnLoadRom(CpsZRom,10,1);
  nPsndIrqPeriod=(60<<10)/500; //OLDTST
  BurnScode=DrvScode;

  // Load ADPCM data
  nRet=BurnLoadRom(CpsAd        ,11,1);
  nRet=BurnLoadRom(CpsAd+0x20000,12,1);

  ConstructCheatList();
  ConstructDIPSWList();

  nRet=CpsRunInit(); if (nRet!=0) return 1;
  // Ready to go
  return 0;
}

// Count possible zip names and (if pszName!=NULL) return them
static int StriderjZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="strider.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="striderj.zip"; return 0; }
  return 1;
}

// Rom information
static struct StdRomInfo StriderjRomDesc[]=
{
  {"sthj23.bin"  ,0x80000,0x046e7b12,0x10}, // 0 even 68000 code
  {"strider.32"  ,0x80000,0x9b3cfc08,0x10}, // 1 both

  // graphics:
  {"strider.06"  ,0x80000,0x4eee9aea,   1}, // 2
  {"strider.08"  ,0x80000,0x2d7f21e4,   1},
  {"strider.02"  ,0x80000,0x7705aa46,   1},
  {"strider.04"  ,0x80000,0x5b18b722,   1},
  {"strider.05"  ,0x80000,0x005f000b,   1}, // 6
  {"strider.07"  ,0x80000,0xb9441519,   1},
  {"strider.01"  ,0x80000,0xb7d04e8b,   1},
  {"strider.03"  ,0x80000,0x6b4713b4,   1},

  // z80 rom
  {"strider.09"  ,0x10000,0x2ed403bc,   1}, // 10
  // samples
  {"strider.18"  ,0x20000,0x4386bc80,   1},
  {"strider.19"  ,0x20000,0x444536d7,   1},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Striderj) STD_ROM_FN(Striderj)

struct BurnDriver BurnDrvCpsStriderj=
{
  {"striderj","Strider Hiryu (Japan Set 1)","","Capcom","CPS1","1989","strider"},
  1,2,HARDWARE_CAPCOM_CPS1,
  StriderjZipName,StriderjRomInfo,StriderjRomName,DrvInputInfo,
  StriderjInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

// ===========================
// Strider Hiryu (Japan Set 2)
// ===========================

// Count possible zip names and (if pszName!=NULL) return them
static int StridrjaZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="strider.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="stridrja.zip"; return 0; }
  return 1;
}

// Rom information
static struct StdRomInfo StridrjaRomDesc[]=
{
  {"sth36.bin"  ,0x20000,0x53c7b006,0x10}, // 0 even 68000 code
  {"sth42.bin"  ,0x20000,0x4037f65f,0x10}, // 1 odd
  {"sth37.bin"  ,0x20000,0x80e8877d,0x10}, // 2 even
  {"sth43.bin"  ,0x20000,0x6b3fa466,0x10}, // 3 odd
  {"strider.32"  ,0x80000,0x9b3cfc08,0x10}, // 4 both

  // graphics:
  {"strider.06"  ,0x80000,0x4eee9aea,   1}, // 5
  {"strider.08"  ,0x80000,0x2d7f21e4,   1},
  {"strider.02"  ,0x80000,0x7705aa46,   1},
  {"strider.04"  ,0x80000,0x5b18b722,   1},
  {"strider.05"  ,0x80000,0x005f000b,   1}, // 9
  {"strider.07"  ,0x80000,0xb9441519,   1},
  {"strider.01"  ,0x80000,0xb7d04e8b,   1},
  {"strider.03"  ,0x80000,0x6b4713b4,   1},

  // z80 rom
  {"strider.09"  ,0x10000,0x2ed403bc,   1}, // 13
  // samples
  {"strider.18"  ,0x20000,0x4386bc80,   1},
  {"strider.19"  ,0x20000,0x444536d7,   1},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Stridrja) STD_ROM_FN(Stridrja)

struct BurnDriver BurnDrvCpsStridrja=
{
  {"stridrja","Strider Hiryu (Japan Set 2)","","Capcom","CPS1","1989","strider"},
  1,2,HARDWARE_CAPCOM_CPS1,
  StridrjaZipName,StridrjaRomInfo,StridrjaRomName,DrvInputInfo,
  StriderInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};
