#include "cps.h"
// U.N. Squadron (Area 88) - All-in-One Driver 1.24 by Mike_Haggar_99@hotmail.com
// U.N. Squadron - Driver by KEV
// Fixes by KEV
// Load menu display adjustment by LoopMaster
// Input menu display amended by Treble Winner
// Cheat engine source by HyperYagami
// Added Dip A/B/C by Bigfool

static struct BurnInputInfo DrvInputList[]=
{
  {"P1 Coin"       , 0, CpsInp018+0, "p1 coin"},
  {"P1 Start"      , 0, CpsInp018+4, "p1 start"},
  {"P1 Up"         , 0, CpsInp001+3, "p1 up"},
  {"P1 Down"       , 0, CpsInp001+2, "p1 down"},
  {"P1 Left"       , 0, CpsInp001+1, "p1 left"},
  {"P1 Right"      , 0, CpsInp001+0, "p1 right"},
  {"P1 Shot"       , 0, CpsInp001+4, "p1 fire 1"},
  {"P1 Special"    , 0, CpsInp001+5, "p1 fire 2"},

  {"P2 Coin"       , 0, CpsInp018+1, "p2 coin"},
  {"P2 Start"      , 0, CpsInp018+5, "p2 start"},
  {"P2 Up"         , 0, CpsInp000+3, "p2 up"},
  {"P2 Down"       , 0, CpsInp000+2, "p2 down"},
  {"P2 Left"       , 0, CpsInp000+1, "p2 left"},
  {"P2 Right"      , 0, CpsInp000+0, "p2 right"},
  {"P2 Shot"       , 0, CpsInp000+4, "p2 fire 1"},
  {"P2 Special"    , 0, CpsInp000+5, "p2 fire 2"},

  {"Reset"         , 0, &CpsReset,   "reset"},
  {"Diagnostic"    , 0, CpsInp018+6, "diag"},
  {"Service"       , 0, CpsInp018+2, "service"},

};

// Return 0 if a input number is defined, and (if pii!=NULL) information about each input
static int DrvInputInfo(struct BurnInputInfo *pii,unsigned int i)
{
  unsigned int nDrvCount=0;
  nDrvCount=sizeof(DrvInputList) /sizeof(DrvInputList[0]);
  if (i<nDrvCount) { if (pii!=NULL) *pii=DrvInputList[i];  return 0; }
  else SETUP_THE_CHEAT_LIST
  else SETUP_THE_DIPSW_LIST
  return 1;
}

static int DrvScode(unsigned int n)
{
	if (n<=0x1f) return 2;
	if (n>=42 && n<=61) return 2;
	return 1;
}

static int DrvInit()
{
  int nRet=0;
  Cps=1;
  nCpsRomLen=   0x100000;
  nCpsCodeLen=0; // not encrypted
  nCpsGfxLen= 4*0x080000;
  nCpsZRomLen=  0x010000;
  nCpsAdLen  =  0x020000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  // Load program roms
  nRet=BurnLoadRom(CpsRom+0x000001,0,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x000000,1,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x040001,2,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x040000,3,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x080000,4,1); if (nRet!=0) return 1; // Already byteswapped
  // Set dip switches
  SETUP_DIPSW_3(Cpi01A,Cpi01C,Cpi01E,0x00,0x03,0x60);
  // Load graphics roms
  CpsLoadTiles(CpsGfx,5);

  ///extra layer  code here

  nCpsLcReg=0x66; // Layer control register is at 0x66
  CpsLayEn[1]=0x20; //layer enable 1 is different
  CpsLayEn[2]=0x10;
  CpsLayEn[3]=0x08; // Layer enable is different
  CpsLayEn[4]=0x00;

  // ends here

  MaskAddr[0]=0x68;
  MaskAddr[1]=0x6a;
  MaskAddr[2]=0x6c;
  MaskAddr[3]=0x6e;

  StartScroll[SCROLL_3]=1;

  // Load Z80 Rom
  nRet=BurnLoadRom(CpsZRom,9,1);
  nPsndIrqPeriod=(60<<10)/250; //OLDTST
  BurnScode=DrvScode;
  // Load ADPCM data
  nRet=BurnLoadRom(CpsAd,10,1);

  ConstructCheatList();
  ConstructDIPSWList();

  nRet=CpsRunInit(); if (nRet!=0) return 1;
  // Ready to go
  return 0;
}

static int DrvExit()
{

DestroyCheatList();
DestroyDIPSWList();

  CpsRunExit();
  BurnScode=NULL;
  nPsndIrqPeriod=0; //OLDTST

  StartScroll[SCROLL_3]=0;

  CpsExit();
  nCpsAdLen=0; nCpsZRomLen=0; nCpsGfxLen=0; nCpsRomLen=0;
  Cps=0;
  return 0;
}

static int DrvFrame()
{

  // HyperYagami: cheats
APPLY_CHEATS(CpsRamFF)

  CpsFsStopOpposite(); // stop opposite directions
  // Carry on to CPS frame
  Cps1Frame();
  return 0;
}

// ===================
// U.N. Squadron (USA)
// ===================

// Count possible zip names and (if pszName!=NULL) return them
static int UnsquadZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="unsquad.zip"; return 0; }
  return 1;
}

// Rom information
static struct StdRomInfo UnsquadRomDesc[]=
{
  {"unsquad.30" ,0x20000,0x24d8f88d,0x10}, // 0 even 68000 code
  {"unsquad.35" ,0x20000,0x8b954b59,0x10}, // 1 odd
  {"unsquad.31" ,0x20000,0x33e9694b,0x10}, // 2 even
  {"unsquad.36" ,0x20000,0x7cc8fb9e,0x10}, // 3 odd
  {"unsquad.32",0x80000,0xae1d7fb0,0x10}, // 4 both

  // graphics:
  {"unsquad.05",0x80000,0xbf4575d8,   1}, // 5
  {"unsquad.07",0x80000,0xa02945f4,   1},
  {"unsquad.01",0x80000,0x5965ca8d,   1},
  {"unsquad.03",0x80000,0xac6db17d,   1},

  // z80 rom
  {"unsquad.09" ,0x10000,0xf3dd1367,   1}, // 9
  // samples
  {"unsquad.18" ,0x20000,0x584b43a9,   1},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Unsquad) STD_ROM_FN(Unsquad)

struct BurnDriver BurnDrvCpsUnsquad=
{
  {"unsquad","U.N. Squadron (USA)","","Capcom","CPS1","1989",NULL},
  1,2,HARDWARE_CAPCOM_CPS1,
  UnsquadZipName,UnsquadRomInfo,UnsquadRomName,DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

// ===============
// Area 88 (Japan)
// ===============

// Count possible zip names and (if pszName!=NULL) return them
static int Area88ZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="unsquad.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="area88.zip"; return 0; }
  return 1;
}

// Rom information
static struct StdRomInfo Area88RomDesc[]=
{
  {"ar36.bin" ,0x20000,0x65030392,0x10}, // 0 even 68000 code
  {"ar42.bin" ,0x20000,0xc48170de,0x10}, // 1 odd
  {"unsquad.31" ,0x20000,0x33e9694b,0x10}, // 2 even
  {"unsquad.36" ,0x20000,0x7cc8fb9e,0x10}, // 3 odd
  {"unsquad.32",0x80000,0xae1d7fb0,0x10}, // 4 both

  // graphics:
  {"unsquad.05",0x80000,0xbf4575d8,   1}, // 5
  {"unsquad.07",0x80000,0xa02945f4,   1},
  {"unsquad.01",0x80000,0x5965ca8d,   1},
  {"unsquad.03",0x80000,0xac6db17d,   1},


  // z80 rom
  {"unsquad.09" ,0x10000,0xf3dd1367,   1}, // 9
  // samples
  {"unsquad.18" ,0x20000,0x584b43a9,   1},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Area88) STD_ROM_FN(Area88)

struct BurnDriver BurnDrvCpsArea88=
{
  {"area88","Area 88 (Japan)","","Capcom","CPS1","1989","unsquad"},
  1,2,HARDWARE_CAPCOM_CPS1,
  Area88ZipName,Area88RomInfo,Area88RomName,DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};
