/****************************************************************/
/* FB CPS1 DipSwitch Engine                                     */
/* By HyperYagami                                               */
/*                                                              */
/* Thanks to everyone for all the                               */
/* help/ideas! (especially ayeye for the original code!)        */
/*                                                              */
/* Revisions:                                                   */
/* Engine: 1st version                                          */
/* Engine Turbo: next revision                                  */
/****************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "burnint.h"

// Universal DIPSW variables
unsigned char *nDIPSW[3];

// default DIPSW values (for 1st-time & reset purposes)
unsigned char nDefaultDIPSWValue[3];

// this things need to be protected,
// don't change its pointer value other than construct/destroy time
struct DIPSWInfo* pDIPSWInfo = NULL;

unsigned char nDIPSWCount;

// Link list construct
void ConstructDIPSWList()
{
	nDIPSWCount = 0;

	char szName[9], szLine[DIPSW_FILE_MAX_CHARS_PER_LINE], szLastDIPSWName[DIPSW_NAME_MAX_LENGTH]="";

	char* szDIPSWToken[DIPSW_MAX_TOKENS], *token;

	unsigned int j;
	unsigned char bShouldQuit;
	struct DIPSWInfo* pSaveDIPSWInfo = NULL;

	FILE *h=NULL; h=fopen("dipinfo\\dipinfo.dat","rt"); if (h==NULL) return;
	sprintf(szName,"%.8s",BurnDrvText(0));

	for (;;)
	{
		if (fgets(szLine,sizeof(szLine),h)==NULL) break;

		// skip comment line
		if ((szLine[0]=='/') && (szLine[1]=='/')) continue;
		// NULL-ify the thing anyway
		szLine[DIPSW_FILE_MAX_CHARS_PER_LINE-1] = 0;
		// Get rid of the linefeed at the end
		int nLen=strlen(szLine);
		if (szLine[nLen-1]==10) { szLine[nLen-1]=0; nLen--; }

		// cleanups for the later sanity checks
		for (j=0;j<DIPSW_MAX_TOKENS;j++)
		{
			if (szDIPSWToken[j]!=NULL) szDIPSWToken[j] = NULL;
			else break;
		}

		// Tokenize the input string
		token = strtok(szLine,":");
		j=0;
		bShouldQuit = 0;
		while ((token!=NULL) && (j<DIPSW_MAX_TOKENS))
		{
			szDIPSWToken[j] = token;
			// if not for this game
			// don't even bother the rest of the string
			if ((j==1) && (_stricmp(szDIPSWToken[j],szName)))
			{bShouldQuit = 1; break;}
			j++;
			token = strtok(NULL, ":");
		}
		if (bShouldQuit==1) {
			strcpy(szLastDIPSWName,"");
			continue;
		}

		if ((j==7)&&(szDIPSWToken[0][0]=='1')) // type 1: 7 tokens
		{
			if (szDIPSWToken[j-2]==NULL) continue;
			if (_stricmp(szDIPSWToken[j-2],szLastDIPSWName))
			{
				// It's new
				// Construct a new DIPSWInfo and store the values
				DIPSWInfo *pTempDIPSWInfo = (DIPSWInfo *)malloc(sizeof(DIPSWInfo));
				pTempDIPSWInfo->pDIPSWChoice = (DIPSWChoice *)malloc(sizeof(DIPSWChoice));

				if (pDIPSWInfo != NULL)
					// we're not the 1st one in the link
					pDIPSWInfo->pNext = pTempDIPSWInfo;
				else
					// we're the 1st one
					pSaveDIPSWInfo = pTempDIPSWInfo;

				// map the stuff plus sanity checks
				pTempDIPSWInfo->nDIPSWType = 1;
				if (szDIPSWToken[5]==NULL) {bShouldQuit = 1; goto ShouldQuit1;}
				strcpy(pTempDIPSWInfo->szDIPSWName,szDIPSWToken[5]);
				if (szDIPSWToken[3]==NULL) {bShouldQuit = 1; goto ShouldQuit1;}
				pTempDIPSWInfo->nDIPSWMask=(unsigned char)strtol(szDIPSWToken[3],NULL,16);
				if (szDIPSWToken[2]==NULL) {bShouldQuit = 1; goto ShouldQuit1;}
				pTempDIPSWInfo->chDIPSWSlot=szDIPSWToken[2][0];
				// uppercase-ize the char
				if (szDIPSWToken[2][0]<=0x63 && szDIPSWToken[2][0]>=0x61)
					pTempDIPSWInfo->chDIPSWSlot-=0x20;
				else if (!(szDIPSWToken[2][0]<=0x43 && szDIPSWToken[2][0]>=0x41))
					{bShouldQuit = 1; goto ShouldQuit1;}
				if (szDIPSWToken[6]==NULL) {bShouldQuit = 1; goto ShouldQuit1;}
				strcpy(pTempDIPSWInfo->pDIPSWChoice->szChoiceName,szDIPSWToken[6]);
				if (szDIPSWToken[4]==NULL) {bShouldQuit = 1; goto ShouldQuit1;}
				pTempDIPSWInfo->pDIPSWChoice->nChoiceWriteValue=(unsigned char)strtol(szDIPSWToken[4],NULL,16);
				pTempDIPSWInfo->pDIPSWChoice->pNext = NULL;
				pTempDIPSWInfo->pNext= NULL;
ShouldQuit1:
				if (bShouldQuit==1)
				{
					free(pTempDIPSWInfo->pDIPSWChoice);
					free(pTempDIPSWInfo);
					continue;
				}

				// move on
				strcpy(szLastDIPSWName,szDIPSWToken[5]);
				pDIPSWInfo = pTempDIPSWInfo;
				nDIPSWCount++;
			}
			else
			{
				// save the current pointer
				DIPSWChoice *pSaveDIPSWChoice = pDIPSWInfo->pDIPSWChoice;

				// run throught the link list
				while (pDIPSWInfo->pDIPSWChoice->pNext!=NULL)
					pDIPSWInfo->pDIPSWChoice = pDIPSWInfo->pDIPSWChoice->pNext;

				// add one more onto the link list
				pDIPSWInfo->pDIPSWChoice->pNext = (DIPSWChoice *)malloc(sizeof(DIPSWChoice));

				// map the stuff plus sanity checks
				if (szDIPSWToken[6]==NULL) {bShouldQuit = 1; goto ShouldQuit2;}
				strcpy(pDIPSWInfo->pDIPSWChoice->pNext->szChoiceName,szDIPSWToken[6]);
				if (szDIPSWToken[4]==NULL) {bShouldQuit = 1; goto ShouldQuit2;}
				pDIPSWInfo->pDIPSWChoice->pNext->nChoiceWriteValue=(unsigned char)strtol(szDIPSWToken[4],NULL,16);
				pDIPSWInfo->pDIPSWChoice->pNext->pNext = NULL;

ShouldQuit2:
				if (bShouldQuit==1) { free(pDIPSWInfo->pDIPSWChoice->pNext); continue; }

				// restore
				pDIPSWInfo->pDIPSWChoice = pSaveDIPSWChoice;
			}
		}
		else if ((j==6)&&(szDIPSWToken[0][0] == '2')) // type 2: 6 tokens
		{
			strcpy(szLastDIPSWName,"");

			// Construct a new DIPSWInfo and store the values
			DIPSWInfo *pTempDIPSWInfo = (DIPSWInfo *)malloc(sizeof(DIPSWInfo));
			if (pDIPSWInfo != NULL)
				// we're not the 1st one in the link
				pDIPSWInfo->pNext = pTempDIPSWInfo;
			else
				// we're the 1st one
				pSaveDIPSWInfo = pTempDIPSWInfo;

			pTempDIPSWInfo->nDIPSWType = 2;

			// map the stuff (2 choices at once) plus sanity checks
			bShouldQuit = 0;
			pTempDIPSWInfo->chDIPSWSlot=szDIPSWToken[2][0];
			// uppercase-ize the char
			if (szDIPSWToken[2][0]<=0x63 && szDIPSWToken[2][0]>=0x61)
				pTempDIPSWInfo->chDIPSWSlot-=0x20;
			else if (!(szDIPSWToken[2][0]<=0x43 && szDIPSWToken[2][0]>=0x41))
				{bShouldQuit = 1; goto ShouldQuit3;}
			if (szDIPSWToken[5]==NULL) {bShouldQuit = 1; goto ShouldQuit3;}
			strcpy(pTempDIPSWInfo->szDIPSWName,szDIPSWToken[5]);
			pTempDIPSWInfo->pDIPSWChoice=(DIPSWChoice *)malloc(sizeof(DIPSWChoice));
			strcpy(pTempDIPSWInfo->pDIPSWChoice->szChoiceName,"Enabled");
			if (szDIPSWToken[3]==NULL) {bShouldQuit = 1; goto ShouldQuit3;}
			pTempDIPSWInfo->pDIPSWChoice->nChoiceWriteValue=(unsigned char)strtol(szDIPSWToken[3],NULL,16);
			pTempDIPSWInfo->pDIPSWChoice->pNext=(DIPSWChoice *)malloc(sizeof(DIPSWChoice));
			strcpy(pTempDIPSWInfo->pDIPSWChoice->pNext->szChoiceName,"Disabled");
			if (szDIPSWToken[4]==NULL) {bShouldQuit = 1; goto ShouldQuit3;}
			pTempDIPSWInfo->pDIPSWChoice->pNext->nChoiceWriteValue=(unsigned char)strtol(szDIPSWToken[4],NULL,16);
			pTempDIPSWInfo->pDIPSWChoice->pNext->pNext=NULL;
			if (pTempDIPSWInfo->pDIPSWChoice->nChoiceWriteValue > pTempDIPSWInfo->pDIPSWChoice->pNext->nChoiceWriteValue)
				pTempDIPSWInfo->nDIPSWMask = pTempDIPSWInfo->pDIPSWChoice->nChoiceWriteValue;
			else
				pTempDIPSWInfo->nDIPSWMask = pTempDIPSWInfo->pDIPSWChoice->pNext->nChoiceWriteValue;
ShouldQuit3:
			if (bShouldQuit==1) { free(pTempDIPSWInfo); continue; }
			
			// move on
			pTempDIPSWInfo->pNext= NULL;
			pDIPSWInfo = pTempDIPSWInfo;
			nDIPSWCount++;
		}
	}
	pDIPSWInfo = pSaveDIPSWInfo;
	fclose(h);
	return;
}

// Link list destory
void DestroyDIPSWList()
{
	// Run through the list and free the things one by one
	DIPSWInfo *pTempDIPSWInfo;
	while (pDIPSWInfo != NULL)
	{
		pTempDIPSWInfo = pDIPSWInfo;
		pDIPSWInfo = pDIPSWInfo->pNext;
		// take care of the dipsw-choice list too
		DIPSWChoice *pTempDIPSWChoice;
		while (pTempDIPSWInfo->pDIPSWChoice != NULL)
		{
			pTempDIPSWChoice = pTempDIPSWInfo->pDIPSWChoice;
			pTempDIPSWInfo->pDIPSWChoice = pTempDIPSWInfo->pDIPSWChoice->pNext;
			free(pTempDIPSWChoice);
		}
		free(pTempDIPSWInfo);
	}
	nDIPSWCount = 0;
}
