/****************************************************************/
/* FB CPS1 DipSwitch Engine                                     */
/* By HyperYagami                                               */
/*                                                              */
/* Thanks to everyone for all the                               */
/* help/ideas! (especially ayeye for the original code!)        */
/*                                                              */
/* Revisions:                                                   */
/* Engine: 1st version                                          */
/* Engine Turbo: next revision                                  */
/****************************************************************/

#define DIPSW_NAME_MAX_LENGTH 64
#define DIPSW_CHOICENAME_MAX_LENGTH 64
#define DIPSW_FILE_MAX_CHARS_PER_LINE 300
#define DIPSW_MAX_TOKENS 7

// DIPSW info struct
struct DIPSWInfo 
{
	// 1 = multiple-choice, 2=On/Off
	unsigned char nDIPSWType; 
	// DIPSW name
	char szDIPSWName[DIPSW_NAME_MAX_LENGTH];
	// DIPSW: A? B? C?
	unsigned char chDIPSWSlot; 
	// DIPSW Mask
	unsigned char nDIPSWMask;
	// DIPSW choices link list pointer
	struct DIPSWChoice *pDIPSWChoice;
	// Link list next pointer
	struct DIPSWInfo *pNext;
};

struct DIPSWChoice
{
	// DIPSW choice name
	char szChoiceName[DIPSW_CHOICENAME_MAX_LENGTH];
	// Corresponding value
	unsigned char nChoiceWriteValue;
	// Link list next pointer
	struct DIPSWChoice *pNext;
};

// Construct the list
extern void ConstructDIPSWList();
// Destory the list
extern void DestroyDIPSWList();

// Setup the DIPSWes (link them to the driver-specific DIPSW variables, 
// default values, etc.)
// 3 DIPSWes (like CPS1)
#define SETUP_DIPSW_3(nDestDIPSWA,nDestDIPSWB,nDestDIPSWC,a,b,c) \
	nDIPSW[0]=&nDestDIPSWA; \
	nDIPSW[1]=&nDestDIPSWB; \
	nDIPSW[2]=&nDestDIPSWC; \
	*nDIPSW[0]=a; \
	*nDIPSW[1]=b; \
	*nDIPSW[2]=c; \
	nDefaultDIPSWValue[0]=a; \
	nDefaultDIPSWValue[1]=b; \
	nDefaultDIPSWValue[2]=c; \

// 2 DIPSWes (Sega)
// nDIPSW[2] now points to a dummy
#define SETUP_DIPSW_2(nDestDIPSWA,nDestDIPSWB,a,b) \
	nDIPSW[0]=&nDestDIPSWA; \
	nDIPSW[1]=&nDestDIPSWB; \
	nDIPSW[2]=&nDefaultDIPSWValue[2]; \
	*nDIPSW[0]=a; \
	*nDIPSW[1]=b; \
	nDefaultDIPSWValue[0]=a; \
	nDefaultDIPSWValue[1]=b; \

// Map those 3 DIPSWes into BurnInputInfo
// Why #define?  Lazyiness
#define SETUP_THE_DIPSW_LIST \
	if ((nDIPSWCount)&&(i<(nDrvCount+nCheatCount+3))) \
	{ \
		if (pii!=NULL) \
		{ \
			switch (i-nDrvCount-nCheatCount) \
			{ \
				case 0: \
					pii->szName = "Dip A"; \
					pii->pVal = nDIPSW[0]; \
					break; \
				case 1: \
					pii->szName = "Dip B"; \
					pii->pVal = nDIPSW[1]; \
					break; \
				case 2: \
					pii->szName = "Dip C"; \
					pii->pVal = nDIPSW[2]; \
					break; \
			} \
			pii->nType = 5; \
			pii->szInfo = "dip"; \
		} \
		return 0; \
	} 

