#include "app.h"

#include <windowsx.h>

#include "kailleraclient.h"

#define KC_BUFFER_MAX 128
#define KC_SCROLL_SPD 100
#define KC_LINE_MAX 	8

//ayeye
typedef DWORD   nHIMC;
#ifdef __GNUC__
 #define WM_IME_STARTCOMPOSITION 269
 #define WM_IME_NOTIFY           642
#endif

typedef BOOL   (WINAPI *pWINNLSEnableIME)(HWND, BOOL);
typedef nHIMC  (WINAPI *pImmGetContext)(HWND);
typedef BOOL   (WINAPI *pImmSetCompositionFont)(nHIMC, LPLOGFONTA);
typedef BOOL   (WINAPI *pImmReleaseContext)(HWND, nHIMC);

pWINNLSEnableIME       nWINNLSEnableIME=NULL;
pImmGetContext         nImmGetContext=NULL;
pImmSetCompositionFont nImmSetCompositionFont=NULL;
pImmReleaseContext     nImmReleaseContext=NULL;
//

// static char szRecvBuf[KC_BUFFER_MAX * 4];			// unused
// static char szChatText[KC_LINE_MAX][KC_BUFFER_MAX];	//
static char szInputBuffer[KC_BUFFER_MAX];

static BOOL	bChatActive = FALSE;

int KailleraChatIsActive(void)
{
	return bChatActive;
}

static void osd_refresh_display()
{
}

static void osd_chat_message(const char*)				// const char* str
{
}

static void GetChatFont(LOGFONT *f)
{
  LOGFONT font;
  font.lfHeight 		= -8;
	font.lfWidth			= 0;
	font.lfEscapement 	= 0;
	font.lfOrientation	= 0;
	font.lfWeight 		= FW_NORMAL;
	font.lfItalic 		= FALSE;
	font.lfUnderline		= FALSE;
	font.lfStrikeOut		= FALSE;
	font.lfCharSet		= ANSI_CHARSET;
	font.lfOutPrecision	= OUT_DEFAULT_PRECIS;
	font.lfClipPrecision	= CLIP_DEFAULT_PRECIS;
	font.lfQuality		= DEFAULT_QUALITY;
	font.lfPitchAndFamily = DEFAULT_PITCH | FF_DONTCARE;
	strcpy(font.lfFaceName, "MS Sans Serif");

  memcpy(f, &font, sizeof(LOGFONT));
}

#define IPT_UI_CHAT_MOVE 1
#define IPT_UI_CHAT_OPEN 2
#define IPT_UI_CANCEL 3

static int input_ui_pressed(int key)
{
  switch(key)
  {
  case IPT_UI_CHAT_OPEN:
    if(hImm32!=NULL)
	{
	  SHORT a=GetKeyState(0x54);
      return (a>>8)&1;
	}
  }
  return 0;
}

static HFONT hChatFont=NULL;
HFONT GetKailleraChatFont(void)
{
  if(hChatFont) return hChatFont;

  LOGFONT 	logfont;

	GetChatFont(&logfont);
	hChatFont = CreateFontIndirect(&logfont);
  return hChatFont;
}

static int GetStatusHeight()
{
  return 0;
}

/* Kaillera Chat Input Window */
static WNDPROC DefEditProc = NULL;
static LRESULT CALLBACK EditProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam);

HWND	hChat		= NULL;
static int	nChatHeight	= 0;
static BOOL	bChatBottom	= FALSE;

/* Kaillera Chat Log Window */
#define CHAT_LOG_STYLE		(WS_CHILD | WS_VSCROLL | ES_LEFT | ES_MULTILINE | ES_READONLY)
#define CHAT_LOG_EX_STYLE	(WS_EX_TOPMOST | WS_EX_CLIENTEDGE)

static WNDPROC DefLogProc = NULL;
static LRESULT CALLBACK LogProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam);

static HWND	hChatLog	= NULL;
static int	nLogHeight	= 0;
static BOOL	bFirstLine	= TRUE;

/* For 8bit color mode */
#define SYSTEMCOLORNUM   4

static COLORREF		saveRgbValues[4];
static const int	elements[4] = {COLOR_WINDOW, COLOR_WINDOWTEXT, COLOR_HIGHLIGHT, COLOR_HIGHLIGHTTEXT};

void KailleraChatAdjustWindow(int width, int height)
{
	if(hChatLog) {
		RECT	rect;
		int		Height;
		SetRect(&rect, 0, 0, 640, nLogHeight);
		AdjustWindowRectEx(&rect, CHAT_LOG_STYLE, FALSE, CHAT_LOG_EX_STYLE);
		Height = rect.bottom - rect.top + 2;
		MoveWindow(hChatLog, 0, height - Height - GetStatusHeight(), width, Height, TRUE);
/*		Height = nLogHeight + 4;
		MoveWindow(hChatLog, 0, height - Height - GetStatusHeight(), width, Height, TRUE);*/
		MoveWindow(hChat, 0, height - Height - nChatHeight - GetStatusHeight(), width, nChatHeight, TRUE);
	} else {
		MoveWindow(hChat, 0, height - nChatHeight - GetStatusHeight(), width, nChatHeight, TRUE);
	}
}

void KailleraChatInit(void)
{
	HFONT		hFont = GetKailleraChatFont();
	HFONT		hOldFont;
	HDC 		hDC;
	TEXTMETRIC	tm;
	RECT		rect;
	int         freeImm32=0;

	bChatActive   = FALSE;

	//ayeye
	if(hImm32!=NULL)
	{
	   if((nWINNLSEnableIME=(pWINNLSEnableIME)GetProcAddress(GetModuleHandle("user32.dll"), "WINNLSEnableIME")) == NULL) freeImm32=1;
       if((nImmGetContext=(pImmGetContext)GetProcAddress(hImm32, "ImmGetContext")) == NULL) freeImm32=1;
	   if((nImmSetCompositionFont=(pImmSetCompositionFont)GetProcAddress(hImm32, "ImmSetCompositionFontA")) == NULL) freeImm32=1;
	   if((nImmReleaseContext=(pImmReleaseContext)GetProcAddress(hImm32, "ImmReleaseContext")) == NULL) freeImm32=1;
	   if(freeImm32==1)
	   {
		   FreeLibrary(hImm32);
		   hImm32=NULL;
		   nWINNLSEnableIME=NULL;
           nImmGetContext=NULL;
           nImmSetCompositionFont=NULL;
           nImmReleaseContext=NULL;
	   }
	}

	hChat = CreateWindowEx(WS_EX_TOPMOST,
						   "EDIT", "",
						   WS_CHILD | ES_AUTOHSCROLL,
						   0, 0, 0, 0,
						   hScrnWnd,
						   NULL,
						   GetModuleHandle(NULL),
						   NULL);

	SetWindowFont(hChat, hFont, FALSE);

	hDC = GetDC(hChat);
	hOldFont = (HFONT)SelectObject(hDC, hFont);
	GetTextMetrics(hDC, &tm);
	SelectObject(hDC, hOldFont);
	ReleaseDC(hChat, hDC);

	nChatHeight = tm.tmHeight + tm.tmExternalLeading + 2;

	GetClientRect(hScrnWnd, &rect);
	KailleraChatAdjustWindow(rect.right, rect.bottom);

	Edit_LimitText(hChat, KC_BUFFER_MAX - 1);
	Edit_Enable(hChat, FALSE);

	if(hImm32!=NULL) (*nWINNLSEnableIME)(hScrnWnd, FALSE);

	DefEditProc = (WNDPROC)GetWindowLong(hChat, GWL_WNDPROC);
	SetWindowLong(hChat, GWL_WNDPROC, (LONG)EditProc);

	{
		int			i;
		for(i = 0; i < SYSTEMCOLORNUM; i++)
			saveRgbValues[i] = GetSysColor(elements[i]);
	}
}

void KailleraChatShutdown(void)
{
	bChatActive   = FALSE;

	SetSysColors(4, elements, saveRgbValues);

	if(hChatLog) {
		if(DefLogProc) {
			SetWindowLong(hChatLog, GWL_WNDPROC, (LONG)DefLogProc);
			DefLogProc = NULL;
		}

		DestroyWindow(hChatLog);
		hChatLog = NULL;
		nLogHeight = 0;
	}

	if(hChat) {
		if(DefEditProc) {
			SetWindowLong(hChat, GWL_WNDPROC, (LONG)DefEditProc);
			DefEditProc = NULL;
		}

		DestroyWindow(hChat);
		hChat = NULL;
		nChatHeight = 0;
	}

	if(hImm32!=NULL) (*nWINNLSEnableIME)(hScrnWnd, FALSE);
}

void KailleraChatSetSysColor(UINT UIPen, UINT BlackPen)
{
    COLORREF sys_colors[SYSTEMCOLORNUM];

	sys_colors[0] = PALETTEINDEX(UIPen);
	sys_colors[1] = PALETTEINDEX(BlackPen);
	sys_colors[2] = PALETTEINDEX(BlackPen);
	sys_colors[3] = PALETTEINDEX(UIPen);
	SetSysColors(SYSTEMCOLORNUM, elements, sys_colors);
}

int KailleraChatHeight(void)
{
	if(hChat == NULL) return 0;

	return nChatHeight;
}

int KailleraChatPosition(void)
{
	return bChatBottom;
}

void KailleraChatCloseChatBox(void)
{
    Edit_Enable(hChat, FALSE);

    ShowWindow(hChat, SW_HIDE);
    Edit_SetText(hChat, "");
    szInputBuffer[0] = '\0';
    SetFocus(hScrnWnd);

    //if(hImm32!=NULL) (*nWINNLSEnableIME)(hChat, FALSE);
	if(hImm32!=NULL) (*nWINNLSEnableIME)(hScrnWnd, FALSE);

    osd_refresh_display();

    bChatActive = FALSE;
}

void KailleraChatUpdate()
{
	if(!bChatActive && input_ui_pressed(IPT_UI_CHAT_MOVE))
	{
		bChatBottom = !bChatBottom;
		osd_chat_message(NULL);			/* show chat log */
		return;
	}
	if(!bChatActive && input_ui_pressed(IPT_UI_CHAT_OPEN))
    {
        Edit_Enable(hChat, TRUE);

        ShowWindow(hChat, SW_SHOW);
        InvalidateRect(hChat, NULL, TRUE);
        SetFocus(hChat);

		if(hImm32!=NULL) (*nWINNLSEnableIME)(hScrnWnd, FALSE);

        osd_refresh_display();

        bChatActive = TRUE;
    }

    if(bChatActive)
        SetFocus(hChat);
}

static LRESULT CALLBACK EditProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	if(hWnd == hChat && nChatHeight) {
		switch (Msg)
		{
		case WM_CHAR:
			switch (wParam)
			{
			case 0x0d: /* Enter */
				if (bChatActive == TRUE)
				{
					Edit_GetText(hChat, szInputBuffer, KC_BUFFER_MAX - 1);

					if (szInputBuffer[0])
					{
						kailleraChatSend(szInputBuffer);
					} else {
						osd_chat_message(NULL);	/* show chat log */
					}
					KailleraChatCloseChatBox();
				}
				return TRUE; /* disable beep */

			case 0x1b: /* Esc */
				KailleraChatCloseChatBox();
				input_ui_pressed(IPT_UI_CANCEL);
				return TRUE; /* disable beep */
			}
			break;

		case WM_IME_STARTCOMPOSITION:
			if (hWnd == hChat && hImm32!=NULL)
			{
				LOGFONT	logfont;
				nHIMC hImc = (*nImmGetContext)(hWnd);

				GetChatFont(&logfont);
				(*nImmSetCompositionFont)(hImc, &logfont);
				(*nImmReleaseContext)(hWnd, hImc);
			}
			break;

		case WM_IME_NOTIFY:
			if (wParam == 0x04 /*IMN_CLOSECANDIDATE*/)
			{
				osd_refresh_display();
				InvalidateRect(hChat, NULL, TRUE);
			}
			break;

		case WM_CONTEXTMENU:
			return TRUE;
		}
	}

	return CallWindowProc(DefEditProc, hWnd, Msg, wParam, lParam);
}

void KailleraChatCreateLogWindow(void)
{
	extern HFONT GetKailleraChatFont(void);

	HFONT		hFont = GetKailleraChatFont();
	HFONT		hOldFont;
	HDC 		hDC;
	TEXTMETRIC	tm;
	RECT		rect;

	hChatLog = CreateWindowEx(CHAT_LOG_EX_STYLE,
						   "EDIT", "",
						   CHAT_LOG_STYLE,
						   0, 0, 0, 0,
						   hScrnWnd,
						   NULL,
						   GetModuleHandle(NULL),
						   NULL);

	SetWindowFont(hChatLog, hFont, FALSE);

	hDC = GetDC(hChatLog);
	hOldFont = (HFONT)SelectObject(hDC, hFont);
	GetTextMetrics(hDC, &tm);
	SelectObject(hDC, hOldFont);
	ReleaseDC(hChatLog, hDC);

	nLogHeight = (tm.tmHeight + tm.tmExternalLeading) * 3;

	GetClientRect(hScrnWnd, &rect);
	KailleraChatAdjustWindow(rect.right, rect.bottom);

	Edit_LimitText(hChatLog, 65535);
	Edit_Enable(hChatLog, TRUE);

	DefLogProc = (WNDPROC)GetWindowLong(hChatLog, GWL_WNDPROC);
	SetWindowLong(hChatLog, GWL_WNDPROC, (LONG)LogProc);

	ShowWindow(hChatLog, SW_SHOW);

	bFirstLine = TRUE;
}

int KailleraChatLogHeight(void)
{
	RECT	rect;

	if(hChatLog == NULL) return 0;

	GetWindowRect(hChatLog, &rect);

	return rect.bottom - rect.top;
}

void KailleraChatLogPut(const char *str)
{
	char	buf[256] = "";
	int		len;

	if(!bFirstLine) strcpy(buf, "\r\n");
	bFirstLine = FALSE;

	strcat(buf, str);

	len = SendMessage(hChatLog, WM_GETTEXTLENGTH, 0, 0);
	SendMessage(hChatLog, EM_SETSEL, len, len);
	SendMessage(hChatLog, EM_REPLACESEL, (WPARAM)FALSE, (LPARAM)buf);
}

static LRESULT CALLBACK LogProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	if(hWnd == hChatLog && nLogHeight) {
		switch(Msg)
		{
		case WM_SETFOCUS:
			SetFocus(GetParent(hWnd));
			return 0;

		case WM_CONTEXTMENU:
			return 0;
		}
	}
	return CallWindowProc(DefLogProc, hWnd, Msg, wParam, lParam);
}
