// Burner CPS1 DipSwitches Dialog module
// By HyperYagami, based on the original code (inpd.cpp) by dayvee
#include "app.h"
#include "dipsw.h"

HWND hInpDIPSWDlg=NULL; // Handle to the DIPSW Dialog
static HWND hInpDIPSWList=NULL;

// Update
static int InpDIPSWUseUpdate()
{
	unsigned int i=0;
	unsigned char temp=0;
	struct DIPSWInfo* pTempDIPSWInfo = pDIPSWInfo;

	if (hInpDIPSWList==NULL) return 1;

	while (pTempDIPSWInfo!=NULL)
	{
		// found out what the current setting is
		temp = (unsigned char)(~*nDIPSW[pTempDIPSWInfo->chDIPSWSlot-65]&pTempDIPSWInfo->nDIPSWMask);
		struct DIPSWChoice* pTempDIPSWChoice=pTempDIPSWInfo->pDIPSWChoice;
		while (pTempDIPSWChoice!=NULL)
		{
			if (pTempDIPSWChoice->nChoiceWriteValue==temp)
			{
				// find a match, add the stuff to the listview
				LVITEM LvItem;
				memset(&LvItem,0,sizeof(LvItem));
				LvItem.mask=LVIF_TEXT;
				LvItem.iItem=i;
				LvItem.iSubItem=0;
				LvItem.pszText=pTempDIPSWInfo->szDIPSWName;
				SendMessage(hInpDIPSWList,LVM_INSERTITEM,0,(LPARAM)&LvItem);
				LvItem.iSubItem=1;
				LvItem.pszText=pTempDIPSWChoice->szChoiceName;
				SendMessage(hInpDIPSWList,LVM_SETITEM,0,(LPARAM)&LvItem);
				break;
			}
			pTempDIPSWChoice=pTempDIPSWChoice->pNext;
		}
		pTempDIPSWInfo=pTempDIPSWInfo->pNext;
		i++;
	}
	return 0;
}

static int InpDIPSWListBegin()
{
	LVCOLUMN LvCol;
	if (hInpDIPSWList==NULL) return 1;
	// Full row select style:
	SendMessage(hInpDIPSWList,LVM_SETEXTENDEDLISTVIEWSTYLE,0,LVS_EX_FULLROWSELECT);

	// Make column headers
	memset(&LvCol,0,sizeof(LvCol));
	LvCol.mask=LVCF_TEXT|LVCF_WIDTH|LVCF_SUBITEM;
	LvCol.cx=0xf0;
	LvCol.pszText="DIPSW Name";
	SendMessage(hInpDIPSWList,LVM_INSERTCOLUMN,0,(LPARAM)&LvCol);

	LvCol.cx=0x94;
	LvCol.pszText="Current Value";
	SendMessage(hInpDIPSWList,LVM_INSERTCOLUMN,1,(LPARAM)&LvCol);

	return 0;
}

// Make a list view of the DIPSWes
int InpDIPSWListMake()
{
	if (hInpDIPSWList==NULL) return 1;
	SendMessage(hInpDIPSWList,LVM_DELETEALLITEMS,0,0);
	InpDIPSWUseUpdate();
	return 0;
}

static int InpDIPSWInit()
{
	// Set the dialog title+label
	SetWindowText(hInpDIPSWDlg,"Edit DIP Switches");
	SetWindowText(GetDlgItem(hInpDIPSWDlg,IDC_PLEASE),"Double-click on a DIP switch to change it");

	hInpDIPSWList=GetDlgItem(hInpDIPSWDlg,IDC_INPCHEAT_LIST);
	InpDIPSWListBegin();
	InpDIPSWListMake();
	return 0;
}

static int InpDIPSWExit()
{
	hInpDIPSWList=NULL;
	hInpDIPSWDlg=NULL;
  if(!bAltPause && bRunPause) bRunPause=0;
	return 0;
}

static int ListItemActivate()
{
	int nSel=0;
	// List item activated
	// Find out which one was activated
	nSel=SendMessage(hInpDIPSWList,LVM_GETNEXTITEM,(unsigned)-1,LVNI_SELECTED);
	if (nSel<0) return 1;
	DIPSWInfo *pTempDIPSWInfo = pDIPSWInfo;
	// point the pInpdXXDIPSWInfo to the correct DIPSWInfo then call the 2nd dialog
	for (int i=0;i<nSel;i++) pTempDIPSWInfo=pTempDIPSWInfo->pNext;
	if (pTempDIPSWInfo->nDIPSWType==1)
	{
		pInpdX1DIPSWInfo=pTempDIPSWInfo;
		InpdX1Create();
	}
	else if (pTempDIPSWInfo->nDIPSWType==2)
	{
		pInpdX2DIPSWInfo=pTempDIPSWInfo;
		InpdX2Create();
	}
	return 0;
}

static BOOL CALLBACK DialogProc(HWND hDlg,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	(void)lParam; (void)wParam; (void)hDlg;
    if (Msg==WM_INITDIALOG) { EnableWindow(hScrnWnd, FALSE); hInpDIPSWDlg=hDlg; InpDIPSWInit(); if(!kNetGame)bRunPause=1; return 1; } // 1 = we didn't set focus?
    if (Msg==WM_CLOSE){ EnableWindow(hScrnWnd, TRUE); DestroyWindow(hInpDIPSWDlg); return 0;}

	if (Msg==WM_DESTROY) { InpDIPSWExit(); return 0; }

	if (Msg==WM_COMMAND)
	{
		int Id=LOWORD(wParam); int Notify=HIWORD(wParam);

		if (Id==IDOK && Notify==BN_CLICKED) { ListItemActivate(); return 0;  }
		if (Id==IDCANCEL && Notify==BN_CLICKED) { SendMessage(hDlg,WM_CLOSE,0,0); return 0; }  // cancel=close
		if (Id==IDC_INPC_RESET && Notify==BN_CLICKED)
		{
			int nRet=0;
			AudSoundStop(); // stop while we display message box
			nRet=MessageBox(
				hDlg,"Reset all DIPSWes?","Reset",
				MB_YESNO | MB_DEFBUTTON2 | MB_ICONWARNING);
			AudSoundPlay(); // restart sound
			if (nRet!=IDYES) return 0; // don't do it
			struct GameInp *pgi=GameInp+(nGameInpCount-3);
			for (int i=0;i<3; i++,pgi++)
			{
				*nDIPSW[i]=nDefaultDIPSWValue[i];
				pgi->nConst=nDefaultDIPSWValue[i];
			}
			InpDIPSWListMake(); // refresh view
			return 0;
		}
	}

	if (Msg==WM_NOTIFY && lParam!=0)
	{
		int Id=LOWORD(wParam); NMHDR *pnm=(NMHDR *)lParam;

		if (Id==IDC_INPCHEAT_LIST && pnm->code==LVN_ITEMACTIVATE)
		{
			ListItemActivate();
		}
		return 0;
	}

	return 0;
}

int InpDIPSWCreate()
{
	if (bDrvOkay==0) return 1; // No game is loaded

	DestroyWindow(hInpDIPSWDlg); // Make sure exitted

	hInpDIPSWDlg=CreateDialog(hAppInst,MAKEINTRESOURCE(IDD_INPCHEAT),hScrnWnd,DialogProc);
	if (hInpDIPSWDlg==NULL) return 1;

	WndInMid(hInpDIPSWDlg,hScrnWnd);
	ShowWindow(hInpDIPSWDlg,SW_NORMAL);
	bRunPause=1;
	return 0;
}
