// Burner CPS1 DipSwitches module EXTENDED, Type 1
// By HyperYagami, based on the original code (inpd.cpp) by dayvee
#include "app.h"
#include "dipsw.h"

HWND hInpdX1Dlg=NULL; // Handle to the Input Dialog
struct DIPSWInfo *pInpdX1DIPSWInfo;

static HWND hValue=NULL; // Handle to value edit control
static struct GameInp *pgi=NULL; // Current GameInp

static int InpdX1Init()
{
	char szText[128];
	unsigned int i=0,temp=0,temp2=0;

	hValue=GetDlgItem(hInpdX1Dlg,IDC_INPCX1_VALUE); // Get Edit controls

	// Set the dialog title
	sprintf(szText,"Edit %.100s",pInpdX1DIPSWInfo->szDIPSWName);
	SetWindowText(hInpdX1Dlg,szText);

	temp = (unsigned char)(~*nDIPSW[pInpdX1DIPSWInfo->chDIPSWSlot-65]&pInpdX1DIPSWInfo->nDIPSWMask);
	DIPSWChoice* pTempDIPSWChoice=pInpdX1DIPSWInfo->pDIPSWChoice;
	i=0;
	while (pTempDIPSWChoice!=NULL)
	{
		SendMessage(hValue,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)pTempDIPSWChoice->szChoiceName);
		// the previous choice, remember it
		if (pTempDIPSWChoice->nChoiceWriteValue==temp) temp2=i;
		pTempDIPSWChoice = pTempDIPSWChoice->pNext;
		i++;
	}
	// select the previous choice automatically
	SendMessage(hValue,CB_SETCURSEL,temp2,0);

	return 0;
}

static int InpdX1Exit()
{
	pgi=NULL;
	hValue=NULL;
	hInpdX1Dlg=NULL;
	return 0;
}

static BOOL CALLBACK DialogProc(HWND hDlg,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	(void)lParam; (void)wParam; (void)hDlg;
	if (Msg==WM_INITDIALOG) { hInpdX1Dlg=hDlg; InpdX1Init(); return 1; } // 1 = we didn't set focus?
	if (Msg==WM_CLOSE) { DestroyWindow(hInpdX1Dlg); return 0; }
	if (Msg==WM_DESTROY) { InpdX1Exit(); return 0; }

	if (Msg==WM_COMMAND)
	{
		int Id=LOWORD(wParam); int Notify=HIWORD(wParam);
		if (Id==IDOK     && Notify==BN_CLICKED) { SendMessage(hDlg,WM_CLOSE,0,0); return 0; } // OK=close
		if (Id==IDCANCEL && Notify==BN_CLICKED) { SendMessage(hDlg,WM_CLOSE,0,0); return 0; } // cancel=close

		if (Id==IDC_INPCX1_VALUE && Notify==CBN_SELCHANGE)
		{
			int nSel = SendMessage(hValue,CB_GETCURSEL,0,0);
			DIPSWChoice* pTempDIPSWChoice=pInpdX1DIPSWInfo->pDIPSWChoice;
			for (int i=0;i<nSel;i++) pTempDIPSWChoice=pTempDIPSWChoice->pNext;

			// 1) mask out the previous value
			// 2) OR it with the (user's choice AND mask)
			pgi=GameInp+(nGameInpCount-(68-pInpdX1DIPSWInfo->chDIPSWSlot));
			*nDIPSW[pInpdX1DIPSWInfo->chDIPSWSlot-65]&=~pInpdX1DIPSWInfo->nDIPSWMask;
			*nDIPSW[pInpdX1DIPSWInfo->chDIPSWSlot-65]|=(~pTempDIPSWChoice->nChoiceWriteValue&pInpdX1DIPSWInfo->nDIPSWMask);
			pgi->nConst=*nDIPSW[pInpdX1DIPSWInfo->chDIPSWSlot-65];

			pgi->nInput=1;
			InpDIPSWListMake();
			return 0;
		}
	}
	return 0;
}

int InpdX1Create()
{
	DestroyWindow(hInpdX1Dlg); hInpdX1Dlg=NULL; // Make sure exitted
	DestroyWindow(hInpdX2Dlg); hInpdX2Dlg=NULL; // Make sure exitted

	hInpdX1Dlg=CreateDialog(hAppInst,MAKEINTRESOURCE(IDD_INPCX1),hInpDIPSWDlg,DialogProc);
	if (hInpdX1Dlg==NULL) return 1;

	WndInMid(hInpdX1Dlg,hInpDIPSWDlg);
	ShowWindow(hInpdX1Dlg,SW_NORMAL);
	return 0;
}
