// Burner CPS1 DipSwitches module EXTENDED, Type 2
// By HyperYagami, based on the original code (inpc.cpp) by dayvee
#include "app.h"
#include "dipsw.h"

HWND hInpdX2Dlg=NULL; // Handle to the Input Dialog
struct DIPSWInfo *pInpdX2DIPSWInfo;

static struct GameInp *pgi=NULL; // Current GameInp
unsigned char bEnabled=0;

static void RefreshPanel()
{
	CheckDlgButton(hInpdX2Dlg,IDC_RADIO_ENABLED,(bEnabled)?BST_CHECKED:BST_UNCHECKED);
	CheckDlgButton(hInpdX2Dlg,IDC_RADIO_DISABLED,!(bEnabled)?BST_CHECKED:BST_UNCHECKED);
}

static int InpdX2Init()
{
	char szText[128];
	unsigned int temp=0;

	// Set the dialog title
	sprintf(szText,"Edit %.100s",pInpdX2DIPSWInfo->szDIPSWName);
	SetWindowText(hInpdX2Dlg,szText);
	temp = (unsigned char)(~*nDIPSW[pInpdX2DIPSWInfo->chDIPSWSlot-65]&pInpdX2DIPSWInfo->nDIPSWMask);
	// if not the "enabled" value then it must be disabled
	bEnabled=(unsigned char)(pInpdX2DIPSWInfo->pDIPSWChoice->nChoiceWriteValue==temp);
	RefreshPanel();
	return 0;
}

static int InpdX2Exit()
{
	pgi=NULL;
	hInpdX2Dlg=NULL;
	return 0;
}

static BOOL CALLBACK DialogProc(HWND hDlg,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	(void)lParam; (void)wParam; (void)hDlg;
	if (Msg==WM_INITDIALOG) { hInpdX2Dlg=hDlg; InpdX2Init(); return 1; } // 1 = we didn't set focus?
	if (Msg==WM_CLOSE) { DestroyWindow(hInpdX2Dlg); return 0; }
	if (Msg==WM_DESTROY) { InpdX2Exit(); return 0; }

	if (Msg==WM_COMMAND)
	{
		int Id=LOWORD(wParam); int Notify=HIWORD(wParam);
		if (Id==IDOK     && Notify==BN_CLICKED) { SendMessage(hDlg,WM_CLOSE,0,0); return 0; } // OK=close
		if (Id==IDCANCEL && Notify==BN_CLICKED) { SendMessage(hDlg,WM_CLOSE,0,0); return 0; } // cancel=close

		if (Id==IDC_RADIO_ENABLED)
		{
			// 1) mask out the previous value
			// 2) OR it with the (user's choice AND mask)
			pgi=GameInp+(nGameInpCount-(68-pInpdX2DIPSWInfo->chDIPSWSlot));
			*nDIPSW[pInpdX2DIPSWInfo->chDIPSWSlot-65]&=~pInpdX2DIPSWInfo->nDIPSWMask;
			*nDIPSW[pInpdX2DIPSWInfo->chDIPSWSlot-65]|=(~pInpdX2DIPSWInfo->pDIPSWChoice->nChoiceWriteValue&pInpdX2DIPSWInfo->nDIPSWMask);
			pgi->nConst=*nDIPSW[pInpdX2DIPSWInfo->chDIPSWSlot-65];

			bEnabled=1;
			pgi->nInput=1;
			InpDIPSWListMake();
			RefreshPanel();
			return 0;
		}

		if (Id==IDC_RADIO_DISABLED)
		{
			// 1) mask out the previous value
			// 2) OR it with the (user's enabled value AND mask)
			pgi=GameInp+(nGameInpCount-(68-pInpdX2DIPSWInfo->chDIPSWSlot));
			*nDIPSW[pInpdX2DIPSWInfo->chDIPSWSlot-65]&=~pInpdX2DIPSWInfo->nDIPSWMask;
			*nDIPSW[pInpdX2DIPSWInfo->chDIPSWSlot-65]|=(~pInpdX2DIPSWInfo->pDIPSWChoice->pNext->nChoiceWriteValue&pInpdX2DIPSWInfo->nDIPSWMask);
			pgi->nConst=*nDIPSW[pInpdX2DIPSWInfo->chDIPSWSlot-65];

			bEnabled=0;
			pgi->nInput=1;
			InpDIPSWListMake();
			RefreshPanel();
			return 0;
		}
	}
	return 0;
}

int InpdX2Create()
{
	DestroyWindow(hInpdX1Dlg); hInpdX1Dlg=NULL; // Make sure exitted
	DestroyWindow(hInpdX2Dlg); hInpdX2Dlg=NULL; // Make sure exitted

	hInpdX2Dlg=CreateDialog(hAppInst,MAKEINTRESOURCE(IDD_INPCX2),hInpDIPSWDlg,DialogProc);
	if (hInpdX2Dlg==NULL) return 1;

	WndInMid(hInpdX2Dlg,hInpDIPSWDlg);
	ShowWindow(hInpdX2Dlg,SW_NORMAL);
	return 0;
}
