// Run module
#include "app.h"
#include "chat.h"

// Kill, Kll, Kill!!!
int DtosNewShortMsg(const char* pText, int nRGB = 0, int nDuration = 0, int nPiority = 0);

int counter;

unsigned int nCurrentFrame;

static unsigned int nNormalLast=0; // Last value of timeGetTime()
static int nNormalFrac=0; // Extra fraction we did

int bRunPause=0;
static int bAppStep=0,bAppFastForward=0;
static int bAppDoFast=0;
static int nFastSpeed=6;
int bAltPause=0;
bool bAltKeyPressed=false;
int bReadInputEveryFrame=0;

// Kaillera stuff starts here
#include "kailleraclient.h"
int kNetGame=0;
// Kaillera stuff ends here

static int GetInput()
{
  static int i=0;
  InputMake(); // get input

  // Update Input + Cheat dialogs ever 3 frames
  if (i==0) {InpdUpdate();}
  i++; if (i>=3) i=0;

  // Update Input Set dialog
  InpsUpdate();
  return 0;
}


// define this function somewhere above RunMessageLoop()
void ToggleLayer(unsigned char thisLayer)
{
   nBurnLayer^=thisLayer; // xor with thisLayer
   VidRedraw();
   VidPaint(0);
}

// With or without sound, run one frame.
// If bDraw is true, it's the last frame before we are up to date, and so we should draw the screen
static int RunFrame(int bDraw,int bPause)
{
  static int bOldStretch=0;

  nCurrentFrame++;

  if (bDraw)
  {
    if (bOldStretch && bDtoStretch==0) // image may have shrunk
    { InvalidateRect(hScrnWnd,NULL,1); UpdateWindow(hScrnWnd); } // blank scrn window
  }
  bOldStretch=bDtoStretch;

  // Get input (even if paused - so it'll show on the dialog)
  if ((bReadInputEveryFrame)||(kNetGame))
  {
    GetInput(); // Get input on all frames but not on netgames
  }
  else
  {
    if (bDraw) GetInput(); // Get input on draw frames only
  }

  InputTick(); // Tick one frame of input (for sliders etc)

  if (!bPause)
  {
// Kaillera stuff starts here
    if(kNetGame)
    {
      int p1off,p2off,p3off,p4off;
      p1off=p2off=p3off=p4off=-1;
      unsigned short values[16]={0,};
      int len=-1;

      for (unsigned int i=0; i<nGameInpCount; i++)
      {
        struct BurnInputInfo bii;
        memset(&bii,0,sizeof(bii));
        BurnDrvGetInputInfo(&bii,i);

        int isP1=!strncmp(bii.szName,"P1",2);
        int isP2=!strncmp(bii.szName,"P2",2);
        int isP3=!strncmp(bii.szName,"P3",2);
        int isP4=!strncmp(bii.szName,"P4",2);

        if(p1off==-1 && isP1) p1off=i;
        if(p2off==-1 && isP2) p2off=i;
        if(p3off==-1 && isP3) p3off=i;
        if(p4off==-1 && isP4) p4off=i;

        if(len==-1 && p1off!=-1 && !isP1) len=i-p1off;

        if(isP1 && *bii.pVal)
        {
          values[0]|=1<<(i-p1off);
        }
        *bii.pVal=0;
      }

      if(kailleraModifyPlayValues(values, 2)==-1)
      {
        kNetGame=0;
        return 0;
      }

	  int i2;						// Can't use i again
	  for(i2=0;i2<16;i2++)
      {
        if(values[0]&(1<<i2))
        {
          struct BurnInputInfo bii;
          memset(&bii,0,sizeof(bii));
          BurnDrvGetInputInfo(&bii,p1off+i2);
          *bii.pVal=1;
        }
      }

      if(p2off!=-1)
      {
        for(i2=0;i2<16;i2++)
        {
          if(values[1]&(1<<i2))
          {
            struct BurnInputInfo bii;
            memset(&bii,0,sizeof(bii));
            BurnDrvGetInputInfo(&bii,p2off+i2);
            *bii.pVal=1;
          }
        }
      }

      if(p3off!=-1)
      {
        for(i2=0;i2<16;i2++)
        {
          if(values[2]&(1<<i2))
          {
            struct BurnInputInfo bii;
            memset(&bii,0,sizeof(bii));
            BurnDrvGetInputInfo(&bii,p3off+i2);
            *bii.pVal=1;
          }
        }
      }

      if(p4off!=-1)
      {
        for(i2=0;i2<16;i2++)
        {
          if(values[3]&(1<<i2))
          {
            struct BurnInputInfo bii;
            memset(&bii,0,sizeof(bii));
            BurnDrvGetInputInfo(&bii,p4off+i2);
            *bii.pVal=1;
          }
        }
      }
	  NetPlay =1;
      KailleraChatUpdate();

    }
// Kaillera stuff ends here

    if (bDraw)
    {
      VidFrame();  // Do one frame
      VidPaint(0); // paint the screen (no need to validate)
    }
    else
    {
      // frame skipping
      pBurnDraw=NULL; // Make sure no image is drawn
      if (bDrvOkay)
      {
        BurnDrvFrame();
      }
    }
  }
  return 0;
}

// Callback used when DSound needs more sound
static int RunGetNextSound(int bDraw)
{
  if (DSoundNextSound==NULL) return 1;

  if (bRunPause && bAppStep==0)
  {
    memset(DSoundNextSound,0,nDSoundSegLen<<2); // Write silence into the buffer
    RunFrame(bDraw,1);
    return 0;
  }

  if (bAppDoFast)
  { int i; for (i=0;i<nFastSpeed;i++) RunFrame(0,0); } // do more frames

  // Render frame with sound
  pBurnSoundOut=NULL;
  if (!bAppStep) pBurnSoundOut=DSoundNextSound;
  RunFrame(bDraw,0);
  if (WaveLog!=NULL && pBurnSoundOut!=NULL)
    fwrite(pBurnSoundOut,1,nBurnSoundLen<<2,WaveLog); // log to the file
  pBurnSoundOut=NULL;

  bAppStep=0; // done one step

  return 0;
}

int RunIdle()
{
  int nTime=0,nCount=0; int i=0;

  if (bDSoundPlaying)
  {
    // Run with sound
    AudSoundCheck();
    return 0;
  }

  // Run without sound
  nTime=timeGetTime()-nNormalLast;
  nCount=(nTime*nAppVirtualFps - nNormalFrac) /10000;
  if (nCount<=0) { Sleep(2); return 0;  } // No need to do anything for a bit

  nNormalFrac+=nCount*10000;
  nNormalLast+=nNormalFrac/nAppVirtualFps;
  nNormalFrac%=nAppVirtualFps;

  if (bAppDoFast) nCount*=nFastSpeed; // temporary increase virtual fps
  if (nCount>10) nCount=10; // Limit frame skipping
  if (bRunPause)
  {
    if (bAppStep) nCount=1; // Step one frame
    else
    {
      RunFrame(1,1); // paused
      return 0;
    }
  }
  bAppStep=0;

  for (i=0;i<nCount-1;i++) { RunFrame(0,0); } // mid-frames
  RunFrame(1,0); // end-frame
  return 0;
}

int RunReset()
{
  // reset the speed throttling code
  nNormalLast=0; nNormalFrac=0;
  if (!bDSoundPlaying)
  {
    // run without sound
    nNormalLast=timeGetTime();
  }
  return 0;
}

static int RunInit()
{
  // Try to run with sound
  DSoundGetNextSound=RunGetNextSound;
  AudSoundPlay();

  RunReset();
  // Get the first input before we start, because we only
  // get input afterwards on draw frames.
  extern int kNetGame;
  if(!kNetGame) GetInput();
  return 0;
}

static int RunExit()
{
  nNormalLast=0;
  // Stop sound if it was playing
  AudSoundStop();
  return 0;
}

// The main message loop
int RunMessageLoop()
{
  int bRestartVideo=0;

RunAgain:

  if (nVidFullscreen) { while (ShowCursor(0)>=0) ; } // hide cursor in fullscreen

  // Size the window for current game
  ScrnSize();

  RunInit();

  bRestartVideo = 0;

  if(kNetGame) KailleraChatInit();

  for (;;)
  {
    MSG Msg; int nRet=0;
    nRet=PeekMessage(&Msg,NULL,0,0,PM_REMOVE);
    if (nRet!=0)
    {
	  // A message is waiting to be processed
      if (Msg.message == WM_QUIT) break; // Quit program
      if (Msg.message == WM_APP + 0)
      {
        bRestartVideo = 1;
        break;
      }

      if (Msg.message == WM_KEYDOWN)
      {

		// Escape key
		if (Msg.wParam == VK_ESCAPE)
		{
		  if (bCmdOptUsed) {
			PostQuitMessage(0);
		  }
		  else
		  {
			if (nVidFullscreen)
			{
			  nVidFullscreen = 0;
			  PostMessage(NULL, WM_APP + 0, 0, 0);
			}
			else
			{
			  if (kNetGame)
			  {
				PanelShow(bPanelDlgIsShown?0:1);
			  }
			}
		  }
		}

		// Hotkeys for savestates
		if (Msg.wParam >= VK_F1 && Msg.wParam <= VK_F9)
		{
		  if (GetAsyncKeyState(VK_CONTROL) & 0x80000000)
		  {
 		    int nSlot = Msg.wParam + 1 - VK_F1;
	  		if (GetAsyncKeyState(VK_SHIFT) & 0x80000000)	// Save state
			{
			  StatedSave(nSlot);
			}
			else											// Load state
			{
			  StatedLoad(nSlot);
			}
		  }
		}

	  }


#ifdef _DEBUG
		// For the "counter"variable
		if ((Msg.message==WM_SYSKEYDOWN || Msg.message==WM_KEYDOWN)) {
			switch (Msg.wParam) {
				case 'N':
					counter--;
					break;
				case 'M':
					counter++;
					break;
			}
		}
#endif

      if ((Msg.message==WM_SYSKEYDOWN || Msg.message==WM_KEYDOWN)&&(Msg.lParam&0x20000000))
      {
        // An Alt/AltGr-key was pressed
        switch (Msg.wParam)
        {
		  case 'I': bAppFastForward=!bAppFastForward; break;
          case 'O': bAppStep=1; break;
          case 'P': bRunPause=!bRunPause; bAltPause=!bAltPause; MenuUpdate(); break;
          case '6': ToggleLayer(1); break;
          case '7': ToggleLayer(2); break;
          case '8': ToggleLayer(4); break;
          case '9': ToggleLayer(8); break;
          case '0': nBurnLayer=0xff; break;
          case 13 : {
            nVidFullscreen=!nVidFullscreen;
			PostMessage(NULL,WM_APP+0,0,0);
			break;
		  }
		  case 0xBB: {
			char buffer[15]="Volume: %lu";
			char *noCtrl="No Volume Control";

			if(nDSoundVol < 0L) nDSoundVol+=100L;

			if(AudSoundSetVolume()==0) DtosNewShortMsg(noCtrl);
			else
			{
			  wsprintf(buffer, buffer, 40L+((nDSoundVol)/100L));
			  DtosNewShortMsg(buffer);
			}
			break;
		  }
		  case 0xBD: {
			char buffer[15]="Volume: %lu";
			char *noCtrl="No Volume Control";

			if(nDSoundVol > -4000L) nDSoundVol-=100L;

			if(AudSoundSetVolume()==0) DtosNewShortMsg(noCtrl);
			else
			{
			  wsprintf(buffer, buffer, 40L+((nDSoundVol)/100L));
	          DtosNewShortMsg(buffer);
			}
			break;
		  }
		}
      }

      // Check for messages for dialogs etc.
      nRet=AppMessage(&Msg);
      if (nRet!=0)
      {
		if(TranslateAccelerator(hScrnWnd, hAccel, &Msg)==0)
		{
          //TranslateMessage(&Msg);
		  if(Msg.hwnd == hChat) TranslateMessage(&Msg);
          DispatchMessage(&Msg);
		}
      }
    }
    else
    {
      HWND hActive=GetActiveWindow();

      bAppDoFast=bAppFastForward;

      if (APP_TAKE_INPUT(hActive)) { if (KEY_DOWN(VK_F7)) bAppDoFast=1; }
      // No messages are waiting
      RunIdle();
    }
  }

  if (nVidFullscreen==0) { while (ShowCursor(1)< 0) ; } // show cursor in windowed

  RunExit();

  if(kNetGame) KailleraChatShutdown();

  if (bRestartVideo)
  {
    int nRet=0;
    VidExit();
    MediaExit();

    MediaInit();

    // Reinit the video plugin
    nRet=VidInit();
    if (nRet!=0) { AppError("VidInit Failed",0); }
	if (bDrvOkay && bRunPause) {
		VidRedraw();
	}
    goto RunAgain;
  }

  return 0;
}
