// Video Output - (calls all the Vid Out plugins)
#include "app.h"

HWND hVidWnd=NULL; // The window to be used for video
int nVidWidth=640,nVidHeight=480,nVidDepth=16,nVidRefresh=0;
int nVidFullscreen=0;
int bVidScanlines=0;
int bVidScanHalf=1;
int bVidScanDelay=1;
int bVidCorrectAspect=1;
int bVidArcaderes=0;				// Use game resolution for fullscreen modes
static unsigned int nVidSelect=0;	// Which video output is selected

extern struct VidOut
  VidOutDto
  ;

static struct VidOut *pVidOut[]=
{
  &VidOutDto,
};

#define VID_LEN (sizeof(pVidOut)/sizeof(pVidOut[0]))

// Forward to VidOut functions
int VidInit()
{
  if (nVidSelect>=VID_LEN) return 1;
  return pVidOut[nVidSelect]->Init();
}

int VidExit()
{
  if (nVidSelect>=VID_LEN) return 1;
  return pVidOut[nVidSelect]->Exit();
}

int VidFrame()
{
  if (nVidSelect>=VID_LEN) return 1;
  return pVidOut[nVidSelect]->Frame(0);
}

int VidRedraw()
{
  if (nVidSelect>=VID_LEN) return 1;
  return pVidOut[nVidSelect]->Frame(1);
}

// If bValidate is 1, the video code should use ValidateRect
// to validate the hVidWnd rectangle it draws.
int VidPaint(int bValidate)
{
  if (nVidSelect>=VID_LEN) return 1;
  return pVidOut[nVidSelect]->Paint(bValidate);
}
