#ifndef APP_INC
#define APP_INC


#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// Make the INLINE macro
#undef INLINE
#define INLINE inline


#define BZIP_MAX (4) // Maximum zip files to search through


// -----------------------------------------------

// zipfn.cpp
struct ZipEntry { char *szName; int nLen; unsigned int nCrc; };
int ZipOpen(char *szZip);
int ZipClose();
int ZipGetList(struct ZipEntry **pList,int *pnListCount);
int ZipLoadFile(unsigned char *Dest,int nLen,int *pnWrote,int nEntry);

#define ZIP_LIST_FREE(List,nListCount) \
{ if (List!=NULL) { int i; for (i=0;i<nListCount;i++) \
  { if (List[i].szName!=NULL) free(List[i].szName);  List[i].szName=NULL; } \
    free(List); } List=NULL; nListCount=0; }

// stringset.cpp
class StringSet
{
public:
  char *szText; int nLen;
  // printf function to add text to the Bzip string
  int Add(char *szFormat,...);
  int Reset();
  StringSet();
  ~StringSet();
};

// bzip.cpp
extern char *szBzipName[BZIP_MAX+1];
extern int nBzipError; // non-zero if there is a problem with the opened romset
extern StringSet BzipText; // Text which describes any problems with loading the zip
extern StringSet BzipDetail; // Text which describes in detail any problems with loading the zip
int BzipOpen();
int BzipClose();
int BzipInit();
int BzipExit();

#endif