#include "burnint.h"

// CPS Scroll2 with row scroll



// Information needed to draw a line
struct LineInfo
{
  int nStart; // 0-0x3ff - where to start drawing tiles from
  int nWidth; // 0-0x400 - width of scroll shifts
  // e.g. for no rowscroll, nStart=nScrollX and nWidth=0
};

static struct LineInfo LineInfo[15];

static INLINE void GetRowsRange(int *pnStart,int *pnWidth,unsigned short *Rows,int nRowCount)
{
  int i,nStart,nWidth;

  // Get the range of scroll values within nRowCount rows
  // Start with zero range
  nStart=Rows[0]; nStart&=0x3ff; nWidth=0;
  for (i=1;i<nRowCount;i++)
  {
    int nViz; int nDiff;
    nViz=Rows[i]; nViz&=0x3ff;
    // Work out if this is on the left or the right of our
    // start point.
    nDiff=nViz-nStart;
    // clip to 10-bit signed
    nDiff=((nDiff+0x200)&0x3ff)-0x200;
    if (nDiff>=0)
    {
      // On the right
      if (nDiff>=nWidth) nWidth=nDiff; // expand width to cover it
    }
    else
    {
      // On the left
      nStart+=nDiff; nStart&=0x3ff;
      nWidth-=nDiff; // expand width to cover it
    }    
  }

  if (nWidth>0x400) nWidth=0x400;

  *pnStart=nStart;
  *pnWidth=nWidth;
}

int CpsScr2RowsPrepare(unsigned char *Base,int nScrollX,int nScrollY,unsigned short *Rows)
{
  int nShiftY;
  int y; struct LineInfo *pli;

  nShiftY=16-(nScrollY&15);

  for (y=-1,pli=LineInfo; y<14; y++,pli++)
  {
    int nStart=0,nWidth=0;

    if (Rows!=NULL)
    {
      int nRowStart,nRowEnd;
      // Find out which rows we need to check
      nRowStart=(y<<4)+nShiftY;
      nRowEnd=nRowStart+16;
      if (nRowStart<0) nRowStart=0;
      if (nRowEnd>224) nRowEnd=224;

      if (nRowEnd<=nRowStart) nRowEnd=nRowStart;

      // Find out what range of scroll values there are for this line
      GetRowsRange(&nStart,&nWidth,Rows+nRowStart,nRowEnd-nRowStart);
    }

    nStart+=nScrollX;

    // Save info in LineInfo table
    pli->nStart=nStart;
    pli->nWidth=nWidth;
  }
  return 0;
}

int CpsScr2RowsDraw(unsigned char *Base,int nScrollX,int nScrollY,unsigned short *Rows)
{
}
